/**
 * <copyright>
 * </copyright>
 *
 * $Id: ActionTypeImpl.java,v 1.3 2005/07/21 15:20:59 daniel_rohe Exp $
 */
package de.strutsbox.strutsconfig.impl;

import de.strutsbox.strutsconfig.ActionType;
import de.strutsbox.strutsconfig.ExceptionType;
import de.strutsbox.strutsconfig.ForwardType;
import de.strutsbox.strutsconfig.RequestScope;
import de.strutsbox.strutsconfig.StrutsConfigPackage;
import de.strutsbox.strutsconfig.Visualizable;

import java.util.Collection;

import org.eclipse.emf.common.notify.Notification;
import org.eclipse.emf.common.notify.NotificationChain;

import org.eclipse.emf.common.util.EList;

import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.EStructuralFeature;
import org.eclipse.emf.ecore.InternalEObject;

import org.eclipse.emf.ecore.impl.ENotificationImpl;

import org.eclipse.emf.ecore.util.EObjectContainmentEList;
import org.eclipse.emf.ecore.util.InternalEList;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model object '<em><b>Action Type</b></em>'.
 * <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * <ul>
 *   <li>{@link de.strutsbox.strutsconfig.impl.ActionTypeImpl#getDisplayName <em>Display Name</em>}</li>
 *   <li>{@link de.strutsbox.strutsconfig.impl.ActionTypeImpl#getDescription <em>Description</em>}</li>
 *   <li>{@link de.strutsbox.strutsconfig.impl.ActionTypeImpl#getSmallIcon <em>Small Icon</em>}</li>
 *   <li>{@link de.strutsbox.strutsconfig.impl.ActionTypeImpl#getLargeIcon <em>Large Icon</em>}</li>
 *   <li>{@link de.strutsbox.strutsconfig.impl.ActionTypeImpl#getId <em>Id</em>}</li>
 *   <li>{@link de.strutsbox.strutsconfig.impl.ActionTypeImpl#getClassName <em>Class Name</em>}</li>
 *   <li>{@link de.strutsbox.strutsconfig.impl.ActionTypeImpl#getPath <em>Path</em>}</li>
 *   <li>{@link de.strutsbox.strutsconfig.impl.ActionTypeImpl#getScope <em>Scope</em>}</li>
 *   <li>{@link de.strutsbox.strutsconfig.impl.ActionTypeImpl#getName <em>Name</em>}</li>
 *   <li>{@link de.strutsbox.strutsconfig.impl.ActionTypeImpl#getType <em>Type</em>}</li>
 *   <li>{@link de.strutsbox.strutsconfig.impl.ActionTypeImpl#getForward1 <em>Forward1</em>}</li>
 *   <li>{@link de.strutsbox.strutsconfig.impl.ActionTypeImpl#getInput <em>Input</em>}</li>
 *   <li>{@link de.strutsbox.strutsconfig.impl.ActionTypeImpl#getAttribute <em>Attribute</em>}</li>
 *   <li>{@link de.strutsbox.strutsconfig.impl.ActionTypeImpl#getInclude <em>Include</em>}</li>
 *   <li>{@link de.strutsbox.strutsconfig.impl.ActionTypeImpl#getParameter <em>Parameter</em>}</li>
 *   <li>{@link de.strutsbox.strutsconfig.impl.ActionTypeImpl#getPrefix <em>Prefix</em>}</li>
 *   <li>{@link de.strutsbox.strutsconfig.impl.ActionTypeImpl#getSuffix <em>Suffix</em>}</li>
 *   <li>{@link de.strutsbox.strutsconfig.impl.ActionTypeImpl#getRoles <em>Roles</em>}</li>
 *   <li>{@link de.strutsbox.strutsconfig.impl.ActionTypeImpl#isUnknown <em>Unknown</em>}</li>
 *   <li>{@link de.strutsbox.strutsconfig.impl.ActionTypeImpl#isValidate <em>Validate</em>}</li>
 *   <li>{@link de.strutsbox.strutsconfig.impl.ActionTypeImpl#getException <em>Exception</em>}</li>
 *   <li>{@link de.strutsbox.strutsconfig.impl.ActionTypeImpl#getForward <em>Forward</em>}</li>
 * </ul>
 * </p>
 *
 * @generated
 */
public class ActionTypeImpl extends ConfigurableImpl implements ActionType {
	/**
	 * The default value of the '{@link #getDisplayName() <em>Display Name</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getDisplayName()
	 * @generated
	 * @ordered
	 */
	protected static final String DISPLAY_NAME_EDEFAULT = null;

	/**
	 * The cached value of the '{@link #getDisplayName() <em>Display Name</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getDisplayName()
	 * @generated
	 * @ordered
	 */
	protected String displayName = DISPLAY_NAME_EDEFAULT;

	/**
	 * The default value of the '{@link #getDescription() <em>Description</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getDescription()
	 * @generated
	 * @ordered
	 */
	protected static final String DESCRIPTION_EDEFAULT = null;

	/**
	 * The cached value of the '{@link #getDescription() <em>Description</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getDescription()
	 * @generated
	 * @ordered
	 */
	protected String description = DESCRIPTION_EDEFAULT;

	/**
	 * The default value of the '{@link #getSmallIcon() <em>Small Icon</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getSmallIcon()
	 * @generated
	 * @ordered
	 */
	protected static final String SMALL_ICON_EDEFAULT = null;

	/**
	 * The cached value of the '{@link #getSmallIcon() <em>Small Icon</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getSmallIcon()
	 * @generated
	 * @ordered
	 */
	protected String smallIcon = SMALL_ICON_EDEFAULT;

	/**
	 * The default value of the '{@link #getLargeIcon() <em>Large Icon</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getLargeIcon()
	 * @generated
	 * @ordered
	 */
	protected static final String LARGE_ICON_EDEFAULT = null;

	/**
	 * The cached value of the '{@link #getLargeIcon() <em>Large Icon</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getLargeIcon()
	 * @generated
	 * @ordered
	 */
	protected String largeIcon = LARGE_ICON_EDEFAULT;

	/**
	 * The default value of the '{@link #getId() <em>Id</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getId()
	 * @generated
	 * @ordered
	 */
	protected static final String ID_EDEFAULT = null;

	/**
	 * The cached value of the '{@link #getId() <em>Id</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getId()
	 * @generated
	 * @ordered
	 */
	protected String id = ID_EDEFAULT;

	/**
	 * The default value of the '{@link #getClassName() <em>Class Name</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getClassName()
	 * @generated
	 * @ordered
	 */
	protected static final String CLASS_NAME_EDEFAULT = null;

	/**
	 * The cached value of the '{@link #getClassName() <em>Class Name</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getClassName()
	 * @generated
	 * @ordered
	 */
	protected String className = CLASS_NAME_EDEFAULT;

	/**
	 * The default value of the '{@link #getPath() <em>Path</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getPath()
	 * @generated
	 * @ordered
	 */
	protected static final String PATH_EDEFAULT = null;

	/**
	 * The cached value of the '{@link #getPath() <em>Path</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getPath()
	 * @generated
	 * @ordered
	 */
	protected String path = PATH_EDEFAULT;

	/**
	 * The default value of the '{@link #getScope() <em>Scope</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getScope()
	 * @generated
	 * @ordered
	 */
	protected static final RequestScope SCOPE_EDEFAULT = RequestScope.REQUEST_LITERAL;

	/**
	 * The cached value of the '{@link #getScope() <em>Scope</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getScope()
	 * @generated
	 * @ordered
	 */
	protected RequestScope scope = SCOPE_EDEFAULT;

	/**
	 * The default value of the '{@link #getName() <em>Name</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getName()
	 * @generated
	 * @ordered
	 */
	protected static final String NAME_EDEFAULT = null;

	/**
	 * The cached value of the '{@link #getName() <em>Name</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getName()
	 * @generated
	 * @ordered
	 */
	protected String name = NAME_EDEFAULT;

	/**
	 * The default value of the '{@link #getType() <em>Type</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getType()
	 * @generated
	 * @ordered
	 */
	protected static final String TYPE_EDEFAULT = null;

	/**
	 * The cached value of the '{@link #getType() <em>Type</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getType()
	 * @generated
	 * @ordered
	 */
	protected String type = TYPE_EDEFAULT;

	/**
	 * The default value of the '{@link #getForward1() <em>Forward1</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getForward1()
	 * @generated
	 * @ordered
	 */
	protected static final String FORWARD1_EDEFAULT = null;

	/**
	 * The cached value of the '{@link #getForward1() <em>Forward1</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getForward1()
	 * @generated
	 * @ordered
	 */
	protected String forward1 = FORWARD1_EDEFAULT;

	/**
	 * The default value of the '{@link #getInput() <em>Input</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getInput()
	 * @generated
	 * @ordered
	 */
	protected static final String INPUT_EDEFAULT = null;

	/**
	 * The cached value of the '{@link #getInput() <em>Input</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getInput()
	 * @generated
	 * @ordered
	 */
	protected String input = INPUT_EDEFAULT;

	/**
	 * The default value of the '{@link #getAttribute() <em>Attribute</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getAttribute()
	 * @generated
	 * @ordered
	 */
	protected static final String ATTRIBUTE_EDEFAULT = null;

	/**
	 * The cached value of the '{@link #getAttribute() <em>Attribute</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getAttribute()
	 * @generated
	 * @ordered
	 */
	protected String attribute = ATTRIBUTE_EDEFAULT;

	/**
	 * The default value of the '{@link #getInclude() <em>Include</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getInclude()
	 * @generated
	 * @ordered
	 */
	protected static final String INCLUDE_EDEFAULT = null;

	/**
	 * The cached value of the '{@link #getInclude() <em>Include</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getInclude()
	 * @generated
	 * @ordered
	 */
	protected String include = INCLUDE_EDEFAULT;

	/**
	 * The default value of the '{@link #getParameter() <em>Parameter</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getParameter()
	 * @generated
	 * @ordered
	 */
	protected static final String PARAMETER_EDEFAULT = null;

	/**
	 * The cached value of the '{@link #getParameter() <em>Parameter</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getParameter()
	 * @generated
	 * @ordered
	 */
	protected String parameter = PARAMETER_EDEFAULT;

	/**
	 * The default value of the '{@link #getPrefix() <em>Prefix</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getPrefix()
	 * @generated
	 * @ordered
	 */
	protected static final String PREFIX_EDEFAULT = null;

	/**
	 * The cached value of the '{@link #getPrefix() <em>Prefix</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getPrefix()
	 * @generated
	 * @ordered
	 */
	protected String prefix = PREFIX_EDEFAULT;

	/**
	 * The default value of the '{@link #getSuffix() <em>Suffix</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getSuffix()
	 * @generated
	 * @ordered
	 */
	protected static final String SUFFIX_EDEFAULT = null;

	/**
	 * The cached value of the '{@link #getSuffix() <em>Suffix</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getSuffix()
	 * @generated
	 * @ordered
	 */
	protected String suffix = SUFFIX_EDEFAULT;

	/**
	 * The default value of the '{@link #getRoles() <em>Roles</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getRoles()
	 * @generated
	 * @ordered
	 */
	protected static final String ROLES_EDEFAULT = null;

	/**
	 * The cached value of the '{@link #getRoles() <em>Roles</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getRoles()
	 * @generated
	 * @ordered
	 */
	protected String roles = ROLES_EDEFAULT;

	/**
	 * The default value of the '{@link #isUnknown() <em>Unknown</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #isUnknown()
	 * @generated
	 * @ordered
	 */
	protected static final boolean UNKNOWN_EDEFAULT = false;

	/**
	 * The cached value of the '{@link #isUnknown() <em>Unknown</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #isUnknown()
	 * @generated
	 * @ordered
	 */
	protected boolean unknown = UNKNOWN_EDEFAULT;

	/**
	 * The default value of the '{@link #isValidate() <em>Validate</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #isValidate()
	 * @generated
	 * @ordered
	 */
	protected static final boolean VALIDATE_EDEFAULT = true;

	/**
	 * The cached value of the '{@link #isValidate() <em>Validate</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #isValidate()
	 * @generated
	 * @ordered
	 */
	protected boolean validate = VALIDATE_EDEFAULT;

	/**
	 * The cached value of the '{@link #getException() <em>Exception</em>}' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getException()
	 * @generated
	 * @ordered
	 */
	protected EList exception = null;

	/**
	 * The cached value of the '{@link #getForward() <em>Forward</em>}' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getForward()
	 * @generated
	 * @ordered
	 */
	protected EList forward = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected ActionTypeImpl() {
		super();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected EClass eStaticClass() {
		return StrutsConfigPackage.eINSTANCE.getActionType();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public String getDisplayName() {
		return displayName;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setDisplayName(String newDisplayName) {
		String oldDisplayName = displayName;
		displayName = newDisplayName;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, StrutsConfigPackage.ACTION_TYPE__DISPLAY_NAME, oldDisplayName, displayName));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public String getDescription() {
		return description;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setDescription(String newDescription) {
		String oldDescription = description;
		description = newDescription;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, StrutsConfigPackage.ACTION_TYPE__DESCRIPTION, oldDescription, description));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public String getSmallIcon() {
		return smallIcon;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setSmallIcon(String newSmallIcon) {
		String oldSmallIcon = smallIcon;
		smallIcon = newSmallIcon;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, StrutsConfigPackage.ACTION_TYPE__SMALL_ICON, oldSmallIcon, smallIcon));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public String getLargeIcon() {
		return largeIcon;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setLargeIcon(String newLargeIcon) {
		String oldLargeIcon = largeIcon;
		largeIcon = newLargeIcon;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, StrutsConfigPackage.ACTION_TYPE__LARGE_ICON, oldLargeIcon, largeIcon));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public String getId() {
		return id;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setId(String newId) {
		String oldId = id;
		id = newId;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, StrutsConfigPackage.ACTION_TYPE__ID, oldId, id));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public String getClassName() {
		return className;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setClassName(String newClassName) {
		String oldClassName = className;
		className = newClassName;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, StrutsConfigPackage.ACTION_TYPE__CLASS_NAME, oldClassName, className));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public String getPath() {
		return path;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setPath(String newPath) {
		String oldPath = path;
		path = newPath;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, StrutsConfigPackage.ACTION_TYPE__PATH, oldPath, path));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public RequestScope getScope() {
		return scope;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setScope(RequestScope newScope) {
		RequestScope oldScope = scope;
		scope = newScope == null ? SCOPE_EDEFAULT : newScope;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, StrutsConfigPackage.ACTION_TYPE__SCOPE, oldScope, scope));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public String getName() {
		return name;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setName(String newName) {
		String oldName = name;
		name = newName;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, StrutsConfigPackage.ACTION_TYPE__NAME, oldName, name));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public String getType() {
		return type;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setType(String newType) {
		String oldType = type;
		type = newType;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, StrutsConfigPackage.ACTION_TYPE__TYPE, oldType, type));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public String getForward1() {
		return forward1;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setForward1(String newForward1) {
		String oldForward1 = forward1;
		forward1 = newForward1;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, StrutsConfigPackage.ACTION_TYPE__FORWARD1, oldForward1, forward1));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public String getInput() {
		return input;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setInput(String newInput) {
		String oldInput = input;
		input = newInput;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, StrutsConfigPackage.ACTION_TYPE__INPUT, oldInput, input));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public String getAttribute() {
		return attribute;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setAttribute(String newAttribute) {
		String oldAttribute = attribute;
		attribute = newAttribute;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, StrutsConfigPackage.ACTION_TYPE__ATTRIBUTE, oldAttribute, attribute));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public String getInclude() {
		return include;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setInclude(String newInclude) {
		String oldInclude = include;
		include = newInclude;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, StrutsConfigPackage.ACTION_TYPE__INCLUDE, oldInclude, include));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public String getParameter() {
		return parameter;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setParameter(String newParameter) {
		String oldParameter = parameter;
		parameter = newParameter;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, StrutsConfigPackage.ACTION_TYPE__PARAMETER, oldParameter, parameter));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public String getPrefix() {
		return prefix;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setPrefix(String newPrefix) {
		String oldPrefix = prefix;
		prefix = newPrefix;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, StrutsConfigPackage.ACTION_TYPE__PREFIX, oldPrefix, prefix));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public String getSuffix() {
		return suffix;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setSuffix(String newSuffix) {
		String oldSuffix = suffix;
		suffix = newSuffix;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, StrutsConfigPackage.ACTION_TYPE__SUFFIX, oldSuffix, suffix));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public String getRoles() {
		return roles;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setRoles(String newRoles) {
		String oldRoles = roles;
		roles = newRoles;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, StrutsConfigPackage.ACTION_TYPE__ROLES, oldRoles, roles));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public boolean isUnknown() {
		return unknown;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setUnknown(boolean newUnknown) {
		boolean oldUnknown = unknown;
		unknown = newUnknown;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, StrutsConfigPackage.ACTION_TYPE__UNKNOWN, oldUnknown, unknown));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public boolean isValidate() {
		return validate;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setValidate(boolean newValidate) {
		boolean oldValidate = validate;
		validate = newValidate;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, StrutsConfigPackage.ACTION_TYPE__VALIDATE, oldValidate, validate));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EList getException() {
		if (exception == null) {
			exception = new EObjectContainmentEList(ExceptionType.class, this, StrutsConfigPackage.ACTION_TYPE__EXCEPTION);
		}
		return exception;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EList getForward() {
		if (forward == null) {
			forward = new EObjectContainmentEList(ForwardType.class, this, StrutsConfigPackage.ACTION_TYPE__FORWARD);
		}
		return forward;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public NotificationChain eInverseRemove(InternalEObject otherEnd, int featureID, Class baseClass, NotificationChain msgs) {
		if (featureID >= 0) {
			switch (eDerivedStructuralFeatureID(featureID, baseClass)) {
				case StrutsConfigPackage.ACTION_TYPE__SET_PROPERTY:
					return ((InternalEList)getSetProperty()).basicRemove(otherEnd, msgs);
				case StrutsConfigPackage.ACTION_TYPE__EXCEPTION:
					return ((InternalEList)getException()).basicRemove(otherEnd, msgs);
				case StrutsConfigPackage.ACTION_TYPE__FORWARD:
					return ((InternalEList)getForward()).basicRemove(otherEnd, msgs);
				default:
					return eDynamicInverseRemove(otherEnd, featureID, baseClass, msgs);
			}
		}
		return eBasicSetContainer(null, featureID, msgs);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public Object eGet(EStructuralFeature eFeature, boolean resolve) {
		switch (eDerivedStructuralFeatureID(eFeature)) {
			case StrutsConfigPackage.ACTION_TYPE__SET_PROPERTY:
				return getSetProperty();
			case StrutsConfigPackage.ACTION_TYPE__DISPLAY_NAME:
				return getDisplayName();
			case StrutsConfigPackage.ACTION_TYPE__DESCRIPTION:
				return getDescription();
			case StrutsConfigPackage.ACTION_TYPE__SMALL_ICON:
				return getSmallIcon();
			case StrutsConfigPackage.ACTION_TYPE__LARGE_ICON:
				return getLargeIcon();
			case StrutsConfigPackage.ACTION_TYPE__ID:
				return getId();
			case StrutsConfigPackage.ACTION_TYPE__CLASS_NAME:
				return getClassName();
			case StrutsConfigPackage.ACTION_TYPE__PATH:
				return getPath();
			case StrutsConfigPackage.ACTION_TYPE__SCOPE:
				return getScope();
			case StrutsConfigPackage.ACTION_TYPE__NAME:
				return getName();
			case StrutsConfigPackage.ACTION_TYPE__TYPE:
				return getType();
			case StrutsConfigPackage.ACTION_TYPE__FORWARD1:
				return getForward1();
			case StrutsConfigPackage.ACTION_TYPE__INPUT:
				return getInput();
			case StrutsConfigPackage.ACTION_TYPE__ATTRIBUTE:
				return getAttribute();
			case StrutsConfigPackage.ACTION_TYPE__INCLUDE:
				return getInclude();
			case StrutsConfigPackage.ACTION_TYPE__PARAMETER:
				return getParameter();
			case StrutsConfigPackage.ACTION_TYPE__PREFIX:
				return getPrefix();
			case StrutsConfigPackage.ACTION_TYPE__SUFFIX:
				return getSuffix();
			case StrutsConfigPackage.ACTION_TYPE__ROLES:
				return getRoles();
			case StrutsConfigPackage.ACTION_TYPE__UNKNOWN:
				return isUnknown() ? Boolean.TRUE : Boolean.FALSE;
			case StrutsConfigPackage.ACTION_TYPE__VALIDATE:
				return isValidate() ? Boolean.TRUE : Boolean.FALSE;
			case StrutsConfigPackage.ACTION_TYPE__EXCEPTION:
				return getException();
			case StrutsConfigPackage.ACTION_TYPE__FORWARD:
				return getForward();
		}
		return eDynamicGet(eFeature, resolve);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void eSet(EStructuralFeature eFeature, Object newValue) {
		switch (eDerivedStructuralFeatureID(eFeature)) {
			case StrutsConfigPackage.ACTION_TYPE__SET_PROPERTY:
				getSetProperty().clear();
				getSetProperty().addAll((Collection)newValue);
				return;
			case StrutsConfigPackage.ACTION_TYPE__DISPLAY_NAME:
				setDisplayName((String)newValue);
				return;
			case StrutsConfigPackage.ACTION_TYPE__DESCRIPTION:
				setDescription((String)newValue);
				return;
			case StrutsConfigPackage.ACTION_TYPE__SMALL_ICON:
				setSmallIcon((String)newValue);
				return;
			case StrutsConfigPackage.ACTION_TYPE__LARGE_ICON:
				setLargeIcon((String)newValue);
				return;
			case StrutsConfigPackage.ACTION_TYPE__ID:
				setId((String)newValue);
				return;
			case StrutsConfigPackage.ACTION_TYPE__CLASS_NAME:
				setClassName((String)newValue);
				return;
			case StrutsConfigPackage.ACTION_TYPE__PATH:
				setPath((String)newValue);
				return;
			case StrutsConfigPackage.ACTION_TYPE__SCOPE:
				setScope((RequestScope)newValue);
				return;
			case StrutsConfigPackage.ACTION_TYPE__NAME:
				setName((String)newValue);
				return;
			case StrutsConfigPackage.ACTION_TYPE__TYPE:
				setType((String)newValue);
				return;
			case StrutsConfigPackage.ACTION_TYPE__FORWARD1:
				setForward1((String)newValue);
				return;
			case StrutsConfigPackage.ACTION_TYPE__INPUT:
				setInput((String)newValue);
				return;
			case StrutsConfigPackage.ACTION_TYPE__ATTRIBUTE:
				setAttribute((String)newValue);
				return;
			case StrutsConfigPackage.ACTION_TYPE__INCLUDE:
				setInclude((String)newValue);
				return;
			case StrutsConfigPackage.ACTION_TYPE__PARAMETER:
				setParameter((String)newValue);
				return;
			case StrutsConfigPackage.ACTION_TYPE__PREFIX:
				setPrefix((String)newValue);
				return;
			case StrutsConfigPackage.ACTION_TYPE__SUFFIX:
				setSuffix((String)newValue);
				return;
			case StrutsConfigPackage.ACTION_TYPE__ROLES:
				setRoles((String)newValue);
				return;
			case StrutsConfigPackage.ACTION_TYPE__UNKNOWN:
				setUnknown(((Boolean)newValue).booleanValue());
				return;
			case StrutsConfigPackage.ACTION_TYPE__VALIDATE:
				setValidate(((Boolean)newValue).booleanValue());
				return;
			case StrutsConfigPackage.ACTION_TYPE__EXCEPTION:
				getException().clear();
				getException().addAll((Collection)newValue);
				return;
			case StrutsConfigPackage.ACTION_TYPE__FORWARD:
				getForward().clear();
				getForward().addAll((Collection)newValue);
				return;
		}
		eDynamicSet(eFeature, newValue);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void eUnset(EStructuralFeature eFeature) {
		switch (eDerivedStructuralFeatureID(eFeature)) {
			case StrutsConfigPackage.ACTION_TYPE__SET_PROPERTY:
				getSetProperty().clear();
				return;
			case StrutsConfigPackage.ACTION_TYPE__DISPLAY_NAME:
				setDisplayName(DISPLAY_NAME_EDEFAULT);
				return;
			case StrutsConfigPackage.ACTION_TYPE__DESCRIPTION:
				setDescription(DESCRIPTION_EDEFAULT);
				return;
			case StrutsConfigPackage.ACTION_TYPE__SMALL_ICON:
				setSmallIcon(SMALL_ICON_EDEFAULT);
				return;
			case StrutsConfigPackage.ACTION_TYPE__LARGE_ICON:
				setLargeIcon(LARGE_ICON_EDEFAULT);
				return;
			case StrutsConfigPackage.ACTION_TYPE__ID:
				setId(ID_EDEFAULT);
				return;
			case StrutsConfigPackage.ACTION_TYPE__CLASS_NAME:
				setClassName(CLASS_NAME_EDEFAULT);
				return;
			case StrutsConfigPackage.ACTION_TYPE__PATH:
				setPath(PATH_EDEFAULT);
				return;
			case StrutsConfigPackage.ACTION_TYPE__SCOPE:
				setScope(SCOPE_EDEFAULT);
				return;
			case StrutsConfigPackage.ACTION_TYPE__NAME:
				setName(NAME_EDEFAULT);
				return;
			case StrutsConfigPackage.ACTION_TYPE__TYPE:
				setType(TYPE_EDEFAULT);
				return;
			case StrutsConfigPackage.ACTION_TYPE__FORWARD1:
				setForward1(FORWARD1_EDEFAULT);
				return;
			case StrutsConfigPackage.ACTION_TYPE__INPUT:
				setInput(INPUT_EDEFAULT);
				return;
			case StrutsConfigPackage.ACTION_TYPE__ATTRIBUTE:
				setAttribute(ATTRIBUTE_EDEFAULT);
				return;
			case StrutsConfigPackage.ACTION_TYPE__INCLUDE:
				setInclude(INCLUDE_EDEFAULT);
				return;
			case StrutsConfigPackage.ACTION_TYPE__PARAMETER:
				setParameter(PARAMETER_EDEFAULT);
				return;
			case StrutsConfigPackage.ACTION_TYPE__PREFIX:
				setPrefix(PREFIX_EDEFAULT);
				return;
			case StrutsConfigPackage.ACTION_TYPE__SUFFIX:
				setSuffix(SUFFIX_EDEFAULT);
				return;
			case StrutsConfigPackage.ACTION_TYPE__ROLES:
				setRoles(ROLES_EDEFAULT);
				return;
			case StrutsConfigPackage.ACTION_TYPE__UNKNOWN:
				setUnknown(UNKNOWN_EDEFAULT);
				return;
			case StrutsConfigPackage.ACTION_TYPE__VALIDATE:
				setValidate(VALIDATE_EDEFAULT);
				return;
			case StrutsConfigPackage.ACTION_TYPE__EXCEPTION:
				getException().clear();
				return;
			case StrutsConfigPackage.ACTION_TYPE__FORWARD:
				getForward().clear();
				return;
		}
		eDynamicUnset(eFeature);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public boolean eIsSet(EStructuralFeature eFeature) {
		switch (eDerivedStructuralFeatureID(eFeature)) {
			case StrutsConfigPackage.ACTION_TYPE__SET_PROPERTY:
				return setProperty != null && !setProperty.isEmpty();
			case StrutsConfigPackage.ACTION_TYPE__DISPLAY_NAME:
				return DISPLAY_NAME_EDEFAULT == null ? displayName != null : !DISPLAY_NAME_EDEFAULT.equals(displayName);
			case StrutsConfigPackage.ACTION_TYPE__DESCRIPTION:
				return DESCRIPTION_EDEFAULT == null ? description != null : !DESCRIPTION_EDEFAULT.equals(description);
			case StrutsConfigPackage.ACTION_TYPE__SMALL_ICON:
				return SMALL_ICON_EDEFAULT == null ? smallIcon != null : !SMALL_ICON_EDEFAULT.equals(smallIcon);
			case StrutsConfigPackage.ACTION_TYPE__LARGE_ICON:
				return LARGE_ICON_EDEFAULT == null ? largeIcon != null : !LARGE_ICON_EDEFAULT.equals(largeIcon);
			case StrutsConfigPackage.ACTION_TYPE__ID:
				return ID_EDEFAULT == null ? id != null : !ID_EDEFAULT.equals(id);
			case StrutsConfigPackage.ACTION_TYPE__CLASS_NAME:
				return CLASS_NAME_EDEFAULT == null ? className != null : !CLASS_NAME_EDEFAULT.equals(className);
			case StrutsConfigPackage.ACTION_TYPE__PATH:
				return PATH_EDEFAULT == null ? path != null : !PATH_EDEFAULT.equals(path);
			case StrutsConfigPackage.ACTION_TYPE__SCOPE:
				return scope != SCOPE_EDEFAULT;
			case StrutsConfigPackage.ACTION_TYPE__NAME:
				return NAME_EDEFAULT == null ? name != null : !NAME_EDEFAULT.equals(name);
			case StrutsConfigPackage.ACTION_TYPE__TYPE:
				return TYPE_EDEFAULT == null ? type != null : !TYPE_EDEFAULT.equals(type);
			case StrutsConfigPackage.ACTION_TYPE__FORWARD1:
				return FORWARD1_EDEFAULT == null ? forward1 != null : !FORWARD1_EDEFAULT.equals(forward1);
			case StrutsConfigPackage.ACTION_TYPE__INPUT:
				return INPUT_EDEFAULT == null ? input != null : !INPUT_EDEFAULT.equals(input);
			case StrutsConfigPackage.ACTION_TYPE__ATTRIBUTE:
				return ATTRIBUTE_EDEFAULT == null ? attribute != null : !ATTRIBUTE_EDEFAULT.equals(attribute);
			case StrutsConfigPackage.ACTION_TYPE__INCLUDE:
				return INCLUDE_EDEFAULT == null ? include != null : !INCLUDE_EDEFAULT.equals(include);
			case StrutsConfigPackage.ACTION_TYPE__PARAMETER:
				return PARAMETER_EDEFAULT == null ? parameter != null : !PARAMETER_EDEFAULT.equals(parameter);
			case StrutsConfigPackage.ACTION_TYPE__PREFIX:
				return PREFIX_EDEFAULT == null ? prefix != null : !PREFIX_EDEFAULT.equals(prefix);
			case StrutsConfigPackage.ACTION_TYPE__SUFFIX:
				return SUFFIX_EDEFAULT == null ? suffix != null : !SUFFIX_EDEFAULT.equals(suffix);
			case StrutsConfigPackage.ACTION_TYPE__ROLES:
				return ROLES_EDEFAULT == null ? roles != null : !ROLES_EDEFAULT.equals(roles);
			case StrutsConfigPackage.ACTION_TYPE__UNKNOWN:
				return unknown != UNKNOWN_EDEFAULT;
			case StrutsConfigPackage.ACTION_TYPE__VALIDATE:
				return validate != VALIDATE_EDEFAULT;
			case StrutsConfigPackage.ACTION_TYPE__EXCEPTION:
				return exception != null && !exception.isEmpty();
			case StrutsConfigPackage.ACTION_TYPE__FORWARD:
				return forward != null && !forward.isEmpty();
		}
		return eDynamicIsSet(eFeature);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public int eBaseStructuralFeatureID(int derivedFeatureID, Class baseClass) {
		if (baseClass == Visualizable.class) {
			switch (derivedFeatureID) {
				case StrutsConfigPackage.ACTION_TYPE__DISPLAY_NAME: return StrutsConfigPackage.VISUALIZABLE__DISPLAY_NAME;
				case StrutsConfigPackage.ACTION_TYPE__DESCRIPTION: return StrutsConfigPackage.VISUALIZABLE__DESCRIPTION;
				case StrutsConfigPackage.ACTION_TYPE__SMALL_ICON: return StrutsConfigPackage.VISUALIZABLE__SMALL_ICON;
				case StrutsConfigPackage.ACTION_TYPE__LARGE_ICON: return StrutsConfigPackage.VISUALIZABLE__LARGE_ICON;
				default: return -1;
			}
		}
		return super.eBaseStructuralFeatureID(derivedFeatureID, baseClass);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public int eDerivedStructuralFeatureID(int baseFeatureID, Class baseClass) {
		if (baseClass == Visualizable.class) {
			switch (baseFeatureID) {
				case StrutsConfigPackage.VISUALIZABLE__DISPLAY_NAME: return StrutsConfigPackage.ACTION_TYPE__DISPLAY_NAME;
				case StrutsConfigPackage.VISUALIZABLE__DESCRIPTION: return StrutsConfigPackage.ACTION_TYPE__DESCRIPTION;
				case StrutsConfigPackage.VISUALIZABLE__SMALL_ICON: return StrutsConfigPackage.ACTION_TYPE__SMALL_ICON;
				case StrutsConfigPackage.VISUALIZABLE__LARGE_ICON: return StrutsConfigPackage.ACTION_TYPE__LARGE_ICON;
				default: return -1;
			}
		}
		return super.eDerivedStructuralFeatureID(baseFeatureID, baseClass);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public String toString() {
		if (eIsProxy()) return super.toString();

		StringBuffer result = new StringBuffer(super.toString());
		result.append(" (displayName: "); //$NON-NLS-1$
		result.append(displayName);
		result.append(", description: "); //$NON-NLS-1$
		result.append(description);
		result.append(", smallIcon: "); //$NON-NLS-1$
		result.append(smallIcon);
		result.append(", largeIcon: "); //$NON-NLS-1$
		result.append(largeIcon);
		result.append(", id: "); //$NON-NLS-1$
		result.append(id);
		result.append(", className: "); //$NON-NLS-1$
		result.append(className);
		result.append(", path: "); //$NON-NLS-1$
		result.append(path);
		result.append(", scope: "); //$NON-NLS-1$
		result.append(scope);
		result.append(", name: "); //$NON-NLS-1$
		result.append(name);
		result.append(", type: "); //$NON-NLS-1$
		result.append(type);
		result.append(", forward1: "); //$NON-NLS-1$
		result.append(forward1);
		result.append(", input: "); //$NON-NLS-1$
		result.append(input);
		result.append(", attribute: "); //$NON-NLS-1$
		result.append(attribute);
		result.append(", include: "); //$NON-NLS-1$
		result.append(include);
		result.append(", parameter: "); //$NON-NLS-1$
		result.append(parameter);
		result.append(", prefix: "); //$NON-NLS-1$
		result.append(prefix);
		result.append(", suffix: "); //$NON-NLS-1$
		result.append(suffix);
		result.append(", roles: "); //$NON-NLS-1$
		result.append(roles);
		result.append(", unknown: "); //$NON-NLS-1$
		result.append(unknown);
		result.append(", validate: "); //$NON-NLS-1$
		result.append(validate);
		result.append(')');
		return result.toString();
	}

} //ActionTypeImpl
