/**
 * <copyright>
 * </copyright>
 *
 * $Id: ExceptionTypeImpl.java,v 1.3 2005/07/21 15:20:59 daniel_rohe Exp $
 */
package de.strutsbox.strutsconfig.impl;

import de.strutsbox.strutsconfig.ExceptionType;
import de.strutsbox.strutsconfig.RequestScope;
import de.strutsbox.strutsconfig.StrutsConfigPackage;
import de.strutsbox.strutsconfig.Visualizable;

import java.util.Collection;

import org.eclipse.emf.common.notify.Notification;
import org.eclipse.emf.common.notify.NotificationChain;

import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.EStructuralFeature;
import org.eclipse.emf.ecore.InternalEObject;

import org.eclipse.emf.ecore.impl.ENotificationImpl;

import org.eclipse.emf.ecore.util.InternalEList;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model object '<em><b>Exception Type</b></em>'.
 * <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * <ul>
 *   <li>{@link de.strutsbox.strutsconfig.impl.ExceptionTypeImpl#getDisplayName <em>Display Name</em>}</li>
 *   <li>{@link de.strutsbox.strutsconfig.impl.ExceptionTypeImpl#getDescription <em>Description</em>}</li>
 *   <li>{@link de.strutsbox.strutsconfig.impl.ExceptionTypeImpl#getSmallIcon <em>Small Icon</em>}</li>
 *   <li>{@link de.strutsbox.strutsconfig.impl.ExceptionTypeImpl#getLargeIcon <em>Large Icon</em>}</li>
 *   <li>{@link de.strutsbox.strutsconfig.impl.ExceptionTypeImpl#getId <em>Id</em>}</li>
 *   <li>{@link de.strutsbox.strutsconfig.impl.ExceptionTypeImpl#getClassName <em>Class Name</em>}</li>
 *   <li>{@link de.strutsbox.strutsconfig.impl.ExceptionTypeImpl#getKey <em>Key</em>}</li>
 *   <li>{@link de.strutsbox.strutsconfig.impl.ExceptionTypeImpl#getType <em>Type</em>}</li>
 *   <li>{@link de.strutsbox.strutsconfig.impl.ExceptionTypeImpl#getHandler <em>Handler</em>}</li>
 *   <li>{@link de.strutsbox.strutsconfig.impl.ExceptionTypeImpl#getPath <em>Path</em>}</li>
 *   <li>{@link de.strutsbox.strutsconfig.impl.ExceptionTypeImpl#getScope <em>Scope</em>}</li>
 *   <li>{@link de.strutsbox.strutsconfig.impl.ExceptionTypeImpl#getBundle <em>Bundle</em>}</li>
 * </ul>
 * </p>
 *
 * @generated
 */
public class ExceptionTypeImpl extends ConfigurableImpl implements ExceptionType {
	/**
	 * The default value of the '{@link #getDisplayName() <em>Display Name</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getDisplayName()
	 * @generated
	 * @ordered
	 */
	protected static final String DISPLAY_NAME_EDEFAULT = null;

	/**
	 * The cached value of the '{@link #getDisplayName() <em>Display Name</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getDisplayName()
	 * @generated
	 * @ordered
	 */
	protected String displayName = DISPLAY_NAME_EDEFAULT;

	/**
	 * The default value of the '{@link #getDescription() <em>Description</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getDescription()
	 * @generated
	 * @ordered
	 */
	protected static final String DESCRIPTION_EDEFAULT = null;

	/**
	 * The cached value of the '{@link #getDescription() <em>Description</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getDescription()
	 * @generated
	 * @ordered
	 */
	protected String description = DESCRIPTION_EDEFAULT;

	/**
	 * The default value of the '{@link #getSmallIcon() <em>Small Icon</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getSmallIcon()
	 * @generated
	 * @ordered
	 */
	protected static final String SMALL_ICON_EDEFAULT = null;

	/**
	 * The cached value of the '{@link #getSmallIcon() <em>Small Icon</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getSmallIcon()
	 * @generated
	 * @ordered
	 */
	protected String smallIcon = SMALL_ICON_EDEFAULT;

	/**
	 * The default value of the '{@link #getLargeIcon() <em>Large Icon</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getLargeIcon()
	 * @generated
	 * @ordered
	 */
	protected static final String LARGE_ICON_EDEFAULT = null;

	/**
	 * The cached value of the '{@link #getLargeIcon() <em>Large Icon</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getLargeIcon()
	 * @generated
	 * @ordered
	 */
	protected String largeIcon = LARGE_ICON_EDEFAULT;

	/**
	 * The default value of the '{@link #getId() <em>Id</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getId()
	 * @generated
	 * @ordered
	 */
	protected static final String ID_EDEFAULT = null;

	/**
	 * The cached value of the '{@link #getId() <em>Id</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getId()
	 * @generated
	 * @ordered
	 */
	protected String id = ID_EDEFAULT;

	/**
	 * The default value of the '{@link #getClassName() <em>Class Name</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getClassName()
	 * @generated
	 * @ordered
	 */
	protected static final String CLASS_NAME_EDEFAULT = null;

	/**
	 * The cached value of the '{@link #getClassName() <em>Class Name</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getClassName()
	 * @generated
	 * @ordered
	 */
	protected String className = CLASS_NAME_EDEFAULT;

	/**
	 * The default value of the '{@link #getKey() <em>Key</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getKey()
	 * @generated
	 * @ordered
	 */
	protected static final String KEY_EDEFAULT = null;

	/**
	 * The cached value of the '{@link #getKey() <em>Key</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getKey()
	 * @generated
	 * @ordered
	 */
	protected String key = KEY_EDEFAULT;

	/**
	 * The default value of the '{@link #getType() <em>Type</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getType()
	 * @generated
	 * @ordered
	 */
	protected static final String TYPE_EDEFAULT = null;

	/**
	 * The cached value of the '{@link #getType() <em>Type</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getType()
	 * @generated
	 * @ordered
	 */
	protected String type = TYPE_EDEFAULT;

	/**
	 * The default value of the '{@link #getHandler() <em>Handler</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getHandler()
	 * @generated
	 * @ordered
	 */
	protected static final String HANDLER_EDEFAULT = null;

	/**
	 * The cached value of the '{@link #getHandler() <em>Handler</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getHandler()
	 * @generated
	 * @ordered
	 */
	protected String handler = HANDLER_EDEFAULT;

	/**
	 * The default value of the '{@link #getPath() <em>Path</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getPath()
	 * @generated
	 * @ordered
	 */
	protected static final String PATH_EDEFAULT = null;

	/**
	 * The cached value of the '{@link #getPath() <em>Path</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getPath()
	 * @generated
	 * @ordered
	 */
	protected String path = PATH_EDEFAULT;

	/**
	 * The default value of the '{@link #getScope() <em>Scope</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getScope()
	 * @generated
	 * @ordered
	 */
	protected static final RequestScope SCOPE_EDEFAULT = RequestScope.REQUEST_LITERAL;

	/**
	 * The cached value of the '{@link #getScope() <em>Scope</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getScope()
	 * @generated
	 * @ordered
	 */
	protected RequestScope scope = SCOPE_EDEFAULT;

	/**
	 * The default value of the '{@link #getBundle() <em>Bundle</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getBundle()
	 * @generated
	 * @ordered
	 */
	protected static final String BUNDLE_EDEFAULT = null;

	/**
	 * The cached value of the '{@link #getBundle() <em>Bundle</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getBundle()
	 * @generated
	 * @ordered
	 */
	protected String bundle = BUNDLE_EDEFAULT;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected ExceptionTypeImpl() {
		super();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected EClass eStaticClass() {
		return StrutsConfigPackage.eINSTANCE.getExceptionType();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public String getDisplayName() {
		return displayName;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setDisplayName(String newDisplayName) {
		String oldDisplayName = displayName;
		displayName = newDisplayName;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, StrutsConfigPackage.EXCEPTION_TYPE__DISPLAY_NAME, oldDisplayName, displayName));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public String getDescription() {
		return description;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setDescription(String newDescription) {
		String oldDescription = description;
		description = newDescription;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, StrutsConfigPackage.EXCEPTION_TYPE__DESCRIPTION, oldDescription, description));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public String getSmallIcon() {
		return smallIcon;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setSmallIcon(String newSmallIcon) {
		String oldSmallIcon = smallIcon;
		smallIcon = newSmallIcon;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, StrutsConfigPackage.EXCEPTION_TYPE__SMALL_ICON, oldSmallIcon, smallIcon));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public String getLargeIcon() {
		return largeIcon;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setLargeIcon(String newLargeIcon) {
		String oldLargeIcon = largeIcon;
		largeIcon = newLargeIcon;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, StrutsConfigPackage.EXCEPTION_TYPE__LARGE_ICON, oldLargeIcon, largeIcon));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public String getId() {
		return id;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setId(String newId) {
		String oldId = id;
		id = newId;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, StrutsConfigPackage.EXCEPTION_TYPE__ID, oldId, id));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public String getClassName() {
		return className;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setClassName(String newClassName) {
		String oldClassName = className;
		className = newClassName;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, StrutsConfigPackage.EXCEPTION_TYPE__CLASS_NAME, oldClassName, className));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public String getKey() {
		return key;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setKey(String newKey) {
		String oldKey = key;
		key = newKey;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, StrutsConfigPackage.EXCEPTION_TYPE__KEY, oldKey, key));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public String getType() {
		return type;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setType(String newType) {
		String oldType = type;
		type = newType;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, StrutsConfigPackage.EXCEPTION_TYPE__TYPE, oldType, type));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public String getHandler() {
		return handler;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setHandler(String newHandler) {
		String oldHandler = handler;
		handler = newHandler;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, StrutsConfigPackage.EXCEPTION_TYPE__HANDLER, oldHandler, handler));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public String getPath() {
		return path;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setPath(String newPath) {
		String oldPath = path;
		path = newPath;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, StrutsConfigPackage.EXCEPTION_TYPE__PATH, oldPath, path));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public RequestScope getScope() {
		return scope;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setScope(RequestScope newScope) {
		RequestScope oldScope = scope;
		scope = newScope == null ? SCOPE_EDEFAULT : newScope;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, StrutsConfigPackage.EXCEPTION_TYPE__SCOPE, oldScope, scope));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public String getBundle() {
		return bundle;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setBundle(String newBundle) {
		String oldBundle = bundle;
		bundle = newBundle;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, StrutsConfigPackage.EXCEPTION_TYPE__BUNDLE, oldBundle, bundle));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public NotificationChain eInverseRemove(InternalEObject otherEnd, int featureID, Class baseClass, NotificationChain msgs) {
		if (featureID >= 0) {
			switch (eDerivedStructuralFeatureID(featureID, baseClass)) {
				case StrutsConfigPackage.EXCEPTION_TYPE__SET_PROPERTY:
					return ((InternalEList)getSetProperty()).basicRemove(otherEnd, msgs);
				default:
					return eDynamicInverseRemove(otherEnd, featureID, baseClass, msgs);
			}
		}
		return eBasicSetContainer(null, featureID, msgs);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public Object eGet(EStructuralFeature eFeature, boolean resolve) {
		switch (eDerivedStructuralFeatureID(eFeature)) {
			case StrutsConfigPackage.EXCEPTION_TYPE__SET_PROPERTY:
				return getSetProperty();
			case StrutsConfigPackage.EXCEPTION_TYPE__DISPLAY_NAME:
				return getDisplayName();
			case StrutsConfigPackage.EXCEPTION_TYPE__DESCRIPTION:
				return getDescription();
			case StrutsConfigPackage.EXCEPTION_TYPE__SMALL_ICON:
				return getSmallIcon();
			case StrutsConfigPackage.EXCEPTION_TYPE__LARGE_ICON:
				return getLargeIcon();
			case StrutsConfigPackage.EXCEPTION_TYPE__ID:
				return getId();
			case StrutsConfigPackage.EXCEPTION_TYPE__CLASS_NAME:
				return getClassName();
			case StrutsConfigPackage.EXCEPTION_TYPE__KEY:
				return getKey();
			case StrutsConfigPackage.EXCEPTION_TYPE__TYPE:
				return getType();
			case StrutsConfigPackage.EXCEPTION_TYPE__HANDLER:
				return getHandler();
			case StrutsConfigPackage.EXCEPTION_TYPE__PATH:
				return getPath();
			case StrutsConfigPackage.EXCEPTION_TYPE__SCOPE:
				return getScope();
			case StrutsConfigPackage.EXCEPTION_TYPE__BUNDLE:
				return getBundle();
		}
		return eDynamicGet(eFeature, resolve);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void eSet(EStructuralFeature eFeature, Object newValue) {
		switch (eDerivedStructuralFeatureID(eFeature)) {
			case StrutsConfigPackage.EXCEPTION_TYPE__SET_PROPERTY:
				getSetProperty().clear();
				getSetProperty().addAll((Collection)newValue);
				return;
			case StrutsConfigPackage.EXCEPTION_TYPE__DISPLAY_NAME:
				setDisplayName((String)newValue);
				return;
			case StrutsConfigPackage.EXCEPTION_TYPE__DESCRIPTION:
				setDescription((String)newValue);
				return;
			case StrutsConfigPackage.EXCEPTION_TYPE__SMALL_ICON:
				setSmallIcon((String)newValue);
				return;
			case StrutsConfigPackage.EXCEPTION_TYPE__LARGE_ICON:
				setLargeIcon((String)newValue);
				return;
			case StrutsConfigPackage.EXCEPTION_TYPE__ID:
				setId((String)newValue);
				return;
			case StrutsConfigPackage.EXCEPTION_TYPE__CLASS_NAME:
				setClassName((String)newValue);
				return;
			case StrutsConfigPackage.EXCEPTION_TYPE__KEY:
				setKey((String)newValue);
				return;
			case StrutsConfigPackage.EXCEPTION_TYPE__TYPE:
				setType((String)newValue);
				return;
			case StrutsConfigPackage.EXCEPTION_TYPE__HANDLER:
				setHandler((String)newValue);
				return;
			case StrutsConfigPackage.EXCEPTION_TYPE__PATH:
				setPath((String)newValue);
				return;
			case StrutsConfigPackage.EXCEPTION_TYPE__SCOPE:
				setScope((RequestScope)newValue);
				return;
			case StrutsConfigPackage.EXCEPTION_TYPE__BUNDLE:
				setBundle((String)newValue);
				return;
		}
		eDynamicSet(eFeature, newValue);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void eUnset(EStructuralFeature eFeature) {
		switch (eDerivedStructuralFeatureID(eFeature)) {
			case StrutsConfigPackage.EXCEPTION_TYPE__SET_PROPERTY:
				getSetProperty().clear();
				return;
			case StrutsConfigPackage.EXCEPTION_TYPE__DISPLAY_NAME:
				setDisplayName(DISPLAY_NAME_EDEFAULT);
				return;
			case StrutsConfigPackage.EXCEPTION_TYPE__DESCRIPTION:
				setDescription(DESCRIPTION_EDEFAULT);
				return;
			case StrutsConfigPackage.EXCEPTION_TYPE__SMALL_ICON:
				setSmallIcon(SMALL_ICON_EDEFAULT);
				return;
			case StrutsConfigPackage.EXCEPTION_TYPE__LARGE_ICON:
				setLargeIcon(LARGE_ICON_EDEFAULT);
				return;
			case StrutsConfigPackage.EXCEPTION_TYPE__ID:
				setId(ID_EDEFAULT);
				return;
			case StrutsConfigPackage.EXCEPTION_TYPE__CLASS_NAME:
				setClassName(CLASS_NAME_EDEFAULT);
				return;
			case StrutsConfigPackage.EXCEPTION_TYPE__KEY:
				setKey(KEY_EDEFAULT);
				return;
			case StrutsConfigPackage.EXCEPTION_TYPE__TYPE:
				setType(TYPE_EDEFAULT);
				return;
			case StrutsConfigPackage.EXCEPTION_TYPE__HANDLER:
				setHandler(HANDLER_EDEFAULT);
				return;
			case StrutsConfigPackage.EXCEPTION_TYPE__PATH:
				setPath(PATH_EDEFAULT);
				return;
			case StrutsConfigPackage.EXCEPTION_TYPE__SCOPE:
				setScope(SCOPE_EDEFAULT);
				return;
			case StrutsConfigPackage.EXCEPTION_TYPE__BUNDLE:
				setBundle(BUNDLE_EDEFAULT);
				return;
		}
		eDynamicUnset(eFeature);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public boolean eIsSet(EStructuralFeature eFeature) {
		switch (eDerivedStructuralFeatureID(eFeature)) {
			case StrutsConfigPackage.EXCEPTION_TYPE__SET_PROPERTY:
				return setProperty != null && !setProperty.isEmpty();
			case StrutsConfigPackage.EXCEPTION_TYPE__DISPLAY_NAME:
				return DISPLAY_NAME_EDEFAULT == null ? displayName != null : !DISPLAY_NAME_EDEFAULT.equals(displayName);
			case StrutsConfigPackage.EXCEPTION_TYPE__DESCRIPTION:
				return DESCRIPTION_EDEFAULT == null ? description != null : !DESCRIPTION_EDEFAULT.equals(description);
			case StrutsConfigPackage.EXCEPTION_TYPE__SMALL_ICON:
				return SMALL_ICON_EDEFAULT == null ? smallIcon != null : !SMALL_ICON_EDEFAULT.equals(smallIcon);
			case StrutsConfigPackage.EXCEPTION_TYPE__LARGE_ICON:
				return LARGE_ICON_EDEFAULT == null ? largeIcon != null : !LARGE_ICON_EDEFAULT.equals(largeIcon);
			case StrutsConfigPackage.EXCEPTION_TYPE__ID:
				return ID_EDEFAULT == null ? id != null : !ID_EDEFAULT.equals(id);
			case StrutsConfigPackage.EXCEPTION_TYPE__CLASS_NAME:
				return CLASS_NAME_EDEFAULT == null ? className != null : !CLASS_NAME_EDEFAULT.equals(className);
			case StrutsConfigPackage.EXCEPTION_TYPE__KEY:
				return KEY_EDEFAULT == null ? key != null : !KEY_EDEFAULT.equals(key);
			case StrutsConfigPackage.EXCEPTION_TYPE__TYPE:
				return TYPE_EDEFAULT == null ? type != null : !TYPE_EDEFAULT.equals(type);
			case StrutsConfigPackage.EXCEPTION_TYPE__HANDLER:
				return HANDLER_EDEFAULT == null ? handler != null : !HANDLER_EDEFAULT.equals(handler);
			case StrutsConfigPackage.EXCEPTION_TYPE__PATH:
				return PATH_EDEFAULT == null ? path != null : !PATH_EDEFAULT.equals(path);
			case StrutsConfigPackage.EXCEPTION_TYPE__SCOPE:
				return scope != SCOPE_EDEFAULT;
			case StrutsConfigPackage.EXCEPTION_TYPE__BUNDLE:
				return BUNDLE_EDEFAULT == null ? bundle != null : !BUNDLE_EDEFAULT.equals(bundle);
		}
		return eDynamicIsSet(eFeature);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public int eBaseStructuralFeatureID(int derivedFeatureID, Class baseClass) {
		if (baseClass == Visualizable.class) {
			switch (derivedFeatureID) {
				case StrutsConfigPackage.EXCEPTION_TYPE__DISPLAY_NAME: return StrutsConfigPackage.VISUALIZABLE__DISPLAY_NAME;
				case StrutsConfigPackage.EXCEPTION_TYPE__DESCRIPTION: return StrutsConfigPackage.VISUALIZABLE__DESCRIPTION;
				case StrutsConfigPackage.EXCEPTION_TYPE__SMALL_ICON: return StrutsConfigPackage.VISUALIZABLE__SMALL_ICON;
				case StrutsConfigPackage.EXCEPTION_TYPE__LARGE_ICON: return StrutsConfigPackage.VISUALIZABLE__LARGE_ICON;
				default: return -1;
			}
		}
		return super.eBaseStructuralFeatureID(derivedFeatureID, baseClass);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public int eDerivedStructuralFeatureID(int baseFeatureID, Class baseClass) {
		if (baseClass == Visualizable.class) {
			switch (baseFeatureID) {
				case StrutsConfigPackage.VISUALIZABLE__DISPLAY_NAME: return StrutsConfigPackage.EXCEPTION_TYPE__DISPLAY_NAME;
				case StrutsConfigPackage.VISUALIZABLE__DESCRIPTION: return StrutsConfigPackage.EXCEPTION_TYPE__DESCRIPTION;
				case StrutsConfigPackage.VISUALIZABLE__SMALL_ICON: return StrutsConfigPackage.EXCEPTION_TYPE__SMALL_ICON;
				case StrutsConfigPackage.VISUALIZABLE__LARGE_ICON: return StrutsConfigPackage.EXCEPTION_TYPE__LARGE_ICON;
				default: return -1;
			}
		}
		return super.eDerivedStructuralFeatureID(baseFeatureID, baseClass);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public String toString() {
		if (eIsProxy()) return super.toString();

		StringBuffer result = new StringBuffer(super.toString());
		result.append(" (displayName: "); //$NON-NLS-1$
		result.append(displayName);
		result.append(", description: "); //$NON-NLS-1$
		result.append(description);
		result.append(", smallIcon: "); //$NON-NLS-1$
		result.append(smallIcon);
		result.append(", largeIcon: "); //$NON-NLS-1$
		result.append(largeIcon);
		result.append(", id: "); //$NON-NLS-1$
		result.append(id);
		result.append(", className: "); //$NON-NLS-1$
		result.append(className);
		result.append(", key: "); //$NON-NLS-1$
		result.append(key);
		result.append(", type: "); //$NON-NLS-1$
		result.append(type);
		result.append(", handler: "); //$NON-NLS-1$
		result.append(handler);
		result.append(", path: "); //$NON-NLS-1$
		result.append(path);
		result.append(", scope: "); //$NON-NLS-1$
		result.append(scope);
		result.append(", bundle: "); //$NON-NLS-1$
		result.append(bundle);
		result.append(')');
		return result.toString();
	}

} //ExceptionTypeImpl
