/**
 * <copyright>
 * </copyright>
 *
 * $Id: ActionType.java,v 1.3 2005/07/21 15:20:59 daniel_rohe Exp $
 */
package de.strutsbox.strutsconfig;

import org.eclipse.emf.common.util.EList;

/**
 * <!-- begin-user-doc -->
 * A representation of the model object '<em><b>Action Type</b></em>'.
 * <!-- end-user-doc -->
 *
 * <p>
 * The following features are supported:
 * <ul>
 *   <li>{@link de.strutsbox.strutsconfig.ActionType#getId <em>Id</em>}</li>
 *   <li>{@link de.strutsbox.strutsconfig.ActionType#getClassName <em>Class Name</em>}</li>
 *   <li>{@link de.strutsbox.strutsconfig.ActionType#getPath <em>Path</em>}</li>
 *   <li>{@link de.strutsbox.strutsconfig.ActionType#getScope <em>Scope</em>}</li>
 *   <li>{@link de.strutsbox.strutsconfig.ActionType#getName <em>Name</em>}</li>
 *   <li>{@link de.strutsbox.strutsconfig.ActionType#getType <em>Type</em>}</li>
 *   <li>{@link de.strutsbox.strutsconfig.ActionType#getForward1 <em>Forward1</em>}</li>
 *   <li>{@link de.strutsbox.strutsconfig.ActionType#getInput <em>Input</em>}</li>
 *   <li>{@link de.strutsbox.strutsconfig.ActionType#getAttribute <em>Attribute</em>}</li>
 *   <li>{@link de.strutsbox.strutsconfig.ActionType#getInclude <em>Include</em>}</li>
 *   <li>{@link de.strutsbox.strutsconfig.ActionType#getParameter <em>Parameter</em>}</li>
 *   <li>{@link de.strutsbox.strutsconfig.ActionType#getPrefix <em>Prefix</em>}</li>
 *   <li>{@link de.strutsbox.strutsconfig.ActionType#getSuffix <em>Suffix</em>}</li>
 *   <li>{@link de.strutsbox.strutsconfig.ActionType#getRoles <em>Roles</em>}</li>
 *   <li>{@link de.strutsbox.strutsconfig.ActionType#isUnknown <em>Unknown</em>}</li>
 *   <li>{@link de.strutsbox.strutsconfig.ActionType#isValidate <em>Validate</em>}</li>
 *   <li>{@link de.strutsbox.strutsconfig.ActionType#getException <em>Exception</em>}</li>
 *   <li>{@link de.strutsbox.strutsconfig.ActionType#getForward <em>Forward</em>}</li>
 * </ul>
 * </p>
 *
 * @see de.strutsbox.strutsconfig.StrutsConfigPackage#getActionType()
 * @model
 * @generated
 */
public interface ActionType extends Configurable, Visualizable {
	/**
	 * Returns the value of the '<em><b>Id</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Id</em>' attribute isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Id</em>' attribute.
	 * @see #setId(String)
	 * @see de.strutsbox.strutsconfig.StrutsConfigPackage#getActionType_Id()
	 * @model id="true"
	 * @generated
	 */
	String getId();

	/**
	 * Sets the value of the '{@link de.strutsbox.strutsconfig.ActionType#getId <em>Id</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Id</em>' attribute.
	 * @see #getId()
	 * @generated
	 */
	void setId(String value);

	/**
	 * Returns the value of the '<em><b>Class Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Class Name</em>' attribute isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Class Name</em>' attribute.
	 * @see #setClassName(String)
	 * @see de.strutsbox.strutsconfig.StrutsConfigPackage#getActionType_ClassName()
	 * @model
	 * @generated
	 */
	String getClassName();

	/**
	 * Sets the value of the '{@link de.strutsbox.strutsconfig.ActionType#getClassName <em>Class Name</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Class Name</em>' attribute.
	 * @see #getClassName()
	 * @generated
	 */
	void setClassName(String value);

	/**
	 * Returns the value of the '<em><b>Path</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Path</em>' attribute isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Path</em>' attribute.
	 * @see #setPath(String)
	 * @see de.strutsbox.strutsconfig.StrutsConfigPackage#getActionType_Path()
	 * @model required="true"
	 * @generated
	 */
	String getPath();

	/**
	 * Sets the value of the '{@link de.strutsbox.strutsconfig.ActionType#getPath <em>Path</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Path</em>' attribute.
	 * @see #getPath()
	 * @generated
	 */
	void setPath(String value);

	/**
	 * Returns the value of the '<em><b>Scope</b></em>' attribute.
	 * The literals are from the enumeration {@link de.strutsbox.strutsconfig.RequestScope}.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Scope</em>' attribute isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Scope</em>' attribute.
	 * @see de.strutsbox.strutsconfig.RequestScope
	 * @see #setScope(RequestScope)
	 * @see de.strutsbox.strutsconfig.StrutsConfigPackage#getActionType_Scope()
	 * @model
	 * @generated
	 */
	RequestScope getScope();

	/**
	 * Sets the value of the '{@link de.strutsbox.strutsconfig.ActionType#getScope <em>Scope</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Scope</em>' attribute.
	 * @see de.strutsbox.strutsconfig.RequestScope
	 * @see #getScope()
	 * @generated
	 */
	void setScope(RequestScope value);

	/**
	 * Returns the value of the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Name</em>' attribute isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Name</em>' attribute.
	 * @see #setName(String)
	 * @see de.strutsbox.strutsconfig.StrutsConfigPackage#getActionType_Name()
	 * @model
	 * @generated
	 */
	String getName();

	/**
	 * Sets the value of the '{@link de.strutsbox.strutsconfig.ActionType#getName <em>Name</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Name</em>' attribute.
	 * @see #getName()
	 * @generated
	 */
	void setName(String value);

	/**
	 * Returns the value of the '<em><b>Type</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Type</em>' attribute isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Type</em>' attribute.
	 * @see #setType(String)
	 * @see de.strutsbox.strutsconfig.StrutsConfigPackage#getActionType_Type()
	 * @model
	 * @generated
	 */
	String getType();

	/**
	 * Sets the value of the '{@link de.strutsbox.strutsconfig.ActionType#getType <em>Type</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Type</em>' attribute.
	 * @see #getType()
	 * @generated
	 */
	void setType(String value);

	/**
	 * Returns the value of the '<em><b>Forward1</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Forward1</em>' attribute isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Forward1</em>' attribute.
	 * @see #setForward1(String)
	 * @see de.strutsbox.strutsconfig.StrutsConfigPackage#getActionType_Forward1()
	 * @model
	 * @generated
	 */
	String getForward1();

	/**
	 * Sets the value of the '{@link de.strutsbox.strutsconfig.ActionType#getForward1 <em>Forward1</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Forward1</em>' attribute.
	 * @see #getForward1()
	 * @generated
	 */
	void setForward1(String value);

	/**
	 * Returns the value of the '<em><b>Input</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Input</em>' attribute isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Input</em>' attribute.
	 * @see #setInput(String)
	 * @see de.strutsbox.strutsconfig.StrutsConfigPackage#getActionType_Input()
	 * @model
	 * @generated
	 */
	String getInput();

	/**
	 * Sets the value of the '{@link de.strutsbox.strutsconfig.ActionType#getInput <em>Input</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Input</em>' attribute.
	 * @see #getInput()
	 * @generated
	 */
	void setInput(String value);

	/**
	 * Returns the value of the '<em><b>Attribute</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Attribute</em>' attribute isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Attribute</em>' attribute.
	 * @see #setAttribute(String)
	 * @see de.strutsbox.strutsconfig.StrutsConfigPackage#getActionType_Attribute()
	 * @model
	 * @generated
	 */
	String getAttribute();

	/**
	 * Sets the value of the '{@link de.strutsbox.strutsconfig.ActionType#getAttribute <em>Attribute</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Attribute</em>' attribute.
	 * @see #getAttribute()
	 * @generated
	 */
	void setAttribute(String value);

	/**
	 * Returns the value of the '<em><b>Include</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Include</em>' attribute isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Include</em>' attribute.
	 * @see #setInclude(String)
	 * @see de.strutsbox.strutsconfig.StrutsConfigPackage#getActionType_Include()
	 * @model
	 * @generated
	 */
	String getInclude();

	/**
	 * Sets the value of the '{@link de.strutsbox.strutsconfig.ActionType#getInclude <em>Include</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Include</em>' attribute.
	 * @see #getInclude()
	 * @generated
	 */
	void setInclude(String value);

	/**
	 * Returns the value of the '<em><b>Parameter</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Parameter</em>' attribute isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Parameter</em>' attribute.
	 * @see #setParameter(String)
	 * @see de.strutsbox.strutsconfig.StrutsConfigPackage#getActionType_Parameter()
	 * @model
	 * @generated
	 */
	String getParameter();

	/**
	 * Sets the value of the '{@link de.strutsbox.strutsconfig.ActionType#getParameter <em>Parameter</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Parameter</em>' attribute.
	 * @see #getParameter()
	 * @generated
	 */
	void setParameter(String value);

	/**
	 * Returns the value of the '<em><b>Prefix</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Prefix</em>' attribute isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Prefix</em>' attribute.
	 * @see #setPrefix(String)
	 * @see de.strutsbox.strutsconfig.StrutsConfigPackage#getActionType_Prefix()
	 * @model
	 * @generated
	 */
	String getPrefix();

	/**
	 * Sets the value of the '{@link de.strutsbox.strutsconfig.ActionType#getPrefix <em>Prefix</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Prefix</em>' attribute.
	 * @see #getPrefix()
	 * @generated
	 */
	void setPrefix(String value);

	/**
	 * Returns the value of the '<em><b>Suffix</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Suffix</em>' attribute isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Suffix</em>' attribute.
	 * @see #setSuffix(String)
	 * @see de.strutsbox.strutsconfig.StrutsConfigPackage#getActionType_Suffix()
	 * @model
	 * @generated
	 */
	String getSuffix();

	/**
	 * Sets the value of the '{@link de.strutsbox.strutsconfig.ActionType#getSuffix <em>Suffix</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Suffix</em>' attribute.
	 * @see #getSuffix()
	 * @generated
	 */
	void setSuffix(String value);

	/**
	 * Returns the value of the '<em><b>Roles</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Roles</em>' attribute isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Roles</em>' attribute.
	 * @see #setRoles(String)
	 * @see de.strutsbox.strutsconfig.StrutsConfigPackage#getActionType_Roles()
	 * @model
	 * @generated
	 */
	String getRoles();

	/**
	 * Sets the value of the '{@link de.strutsbox.strutsconfig.ActionType#getRoles <em>Roles</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Roles</em>' attribute.
	 * @see #getRoles()
	 * @generated
	 */
	void setRoles(String value);

	/**
	 * Returns the value of the '<em><b>Unknown</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Unknown</em>' attribute isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Unknown</em>' attribute.
	 * @see #setUnknown(boolean)
	 * @see de.strutsbox.strutsconfig.StrutsConfigPackage#getActionType_Unknown()
	 * @model
	 * @generated
	 */
	boolean isUnknown();

	/**
	 * Sets the value of the '{@link de.strutsbox.strutsconfig.ActionType#isUnknown <em>Unknown</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Unknown</em>' attribute.
	 * @see #isUnknown()
	 * @generated
	 */
	void setUnknown(boolean value);

	/**
	 * Returns the value of the '<em><b>Validate</b></em>' attribute.
	 * The default value is <code>"true"</code>.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Validate</em>' attribute isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Validate</em>' attribute.
	 * @see #setValidate(boolean)
	 * @see de.strutsbox.strutsconfig.StrutsConfigPackage#getActionType_Validate()
	 * @model default="true"
	 * @generated
	 */
	boolean isValidate();

	/**
	 * Sets the value of the '{@link de.strutsbox.strutsconfig.ActionType#isValidate <em>Validate</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Validate</em>' attribute.
	 * @see #isValidate()
	 * @generated
	 */
	void setValidate(boolean value);

	/**
	 * Returns the value of the '<em><b>Exception</b></em>' containment reference list.
	 * The list contents are of type {@link de.strutsbox.strutsconfig.ExceptionType}.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Exception</em>' containment reference list isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Exception</em>' containment reference list.
	 * @see de.strutsbox.strutsconfig.StrutsConfigPackage#getActionType_Exception()
	 * @model type="de.strutsbox.strutsconfig.ExceptionType" containment="true" resolveProxies="false"
	 * @generated
	 */
	EList getException();

	/**
	 * Returns the value of the '<em><b>Forward</b></em>' containment reference list.
	 * The list contents are of type {@link de.strutsbox.strutsconfig.ForwardType}.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Forward</em>' containment reference list isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Forward</em>' containment reference list.
	 * @see de.strutsbox.strutsconfig.StrutsConfigPackage#getActionType_Forward()
	 * @model type="de.strutsbox.strutsconfig.ForwardType" containment="true" resolveProxies="false"
	 * @generated
	 */
	EList getForward();

} // ActionType
