/**
 * <copyright>
 * </copyright>
 *
 * $Id: ControllerTypeImpl.java,v 1.3 2005/07/21 15:20:59 daniel_rohe Exp $
 */
package de.strutsbox.strutsconfig.impl;

import de.strutsbox.strutsconfig.ControllerType;
import de.strutsbox.strutsconfig.StrutsConfigPackage;

import java.util.Collection;

import org.eclipse.emf.common.notify.Notification;
import org.eclipse.emf.common.notify.NotificationChain;

import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.EStructuralFeature;
import org.eclipse.emf.ecore.InternalEObject;

import org.eclipse.emf.ecore.impl.ENotificationImpl;

import org.eclipse.emf.ecore.util.InternalEList;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model object '<em><b>Controller Type</b></em>'.
 * <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * <ul>
 *   <li>{@link de.strutsbox.strutsconfig.impl.ControllerTypeImpl#getId <em>Id</em>}</li>
 *   <li>{@link de.strutsbox.strutsconfig.impl.ControllerTypeImpl#getClassName <em>Class Name</em>}</li>
 *   <li>{@link de.strutsbox.strutsconfig.impl.ControllerTypeImpl#getBufferSize <em>Buffer Size</em>}</li>
 *   <li>{@link de.strutsbox.strutsconfig.impl.ControllerTypeImpl#getContentType <em>Content Type</em>}</li>
 *   <li>{@link de.strutsbox.strutsconfig.impl.ControllerTypeImpl#getForwardPattern <em>Forward Pattern</em>}</li>
 *   <li>{@link de.strutsbox.strutsconfig.impl.ControllerTypeImpl#isInputForward <em>Input Forward</em>}</li>
 *   <li>{@link de.strutsbox.strutsconfig.impl.ControllerTypeImpl#isLocale <em>Locale</em>}</li>
 *   <li>{@link de.strutsbox.strutsconfig.impl.ControllerTypeImpl#getMaxFileSize <em>Max File Size</em>}</li>
 *   <li>{@link de.strutsbox.strutsconfig.impl.ControllerTypeImpl#getMemFileSize <em>Mem File Size</em>}</li>
 *   <li>{@link de.strutsbox.strutsconfig.impl.ControllerTypeImpl#getMultipartClass <em>Multipart Class</em>}</li>
 *   <li>{@link de.strutsbox.strutsconfig.impl.ControllerTypeImpl#isNocache <em>Nocache</em>}</li>
 *   <li>{@link de.strutsbox.strutsconfig.impl.ControllerTypeImpl#getPagePattern <em>Page Pattern</em>}</li>
 *   <li>{@link de.strutsbox.strutsconfig.impl.ControllerTypeImpl#getProcessorClass <em>Processor Class</em>}</li>
 *   <li>{@link de.strutsbox.strutsconfig.impl.ControllerTypeImpl#getTempDir <em>Temp Dir</em>}</li>
 * </ul>
 * </p>
 *
 * @generated
 */
public class ControllerTypeImpl extends ConfigurableImpl implements ControllerType {
	/**
	 * The default value of the '{@link #getId() <em>Id</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getId()
	 * @generated
	 * @ordered
	 */
	protected static final String ID_EDEFAULT = null;

	/**
	 * The cached value of the '{@link #getId() <em>Id</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getId()
	 * @generated
	 * @ordered
	 */
	protected String id = ID_EDEFAULT;

	/**
	 * The default value of the '{@link #getClassName() <em>Class Name</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getClassName()
	 * @generated
	 * @ordered
	 */
	protected static final String CLASS_NAME_EDEFAULT = null;

	/**
	 * The cached value of the '{@link #getClassName() <em>Class Name</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getClassName()
	 * @generated
	 * @ordered
	 */
	protected String className = CLASS_NAME_EDEFAULT;

	/**
	 * The default value of the '{@link #getBufferSize() <em>Buffer Size</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getBufferSize()
	 * @generated
	 * @ordered
	 */
	protected static final int BUFFER_SIZE_EDEFAULT = 0;

	/**
	 * The cached value of the '{@link #getBufferSize() <em>Buffer Size</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getBufferSize()
	 * @generated
	 * @ordered
	 */
	protected int bufferSize = BUFFER_SIZE_EDEFAULT;

	/**
	 * The default value of the '{@link #getContentType() <em>Content Type</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getContentType()
	 * @generated
	 * @ordered
	 */
	protected static final String CONTENT_TYPE_EDEFAULT = null;

	/**
	 * The cached value of the '{@link #getContentType() <em>Content Type</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getContentType()
	 * @generated
	 * @ordered
	 */
	protected String contentType = CONTENT_TYPE_EDEFAULT;

	/**
	 * The default value of the '{@link #getForwardPattern() <em>Forward Pattern</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getForwardPattern()
	 * @generated
	 * @ordered
	 */
	protected static final String FORWARD_PATTERN_EDEFAULT = null;

	/**
	 * The cached value of the '{@link #getForwardPattern() <em>Forward Pattern</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getForwardPattern()
	 * @generated
	 * @ordered
	 */
	protected String forwardPattern = FORWARD_PATTERN_EDEFAULT;

	/**
	 * The default value of the '{@link #isInputForward() <em>Input Forward</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #isInputForward()
	 * @generated
	 * @ordered
	 */
	protected static final boolean INPUT_FORWARD_EDEFAULT = false;

	/**
	 * The cached value of the '{@link #isInputForward() <em>Input Forward</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #isInputForward()
	 * @generated
	 * @ordered
	 */
	protected boolean inputForward = INPUT_FORWARD_EDEFAULT;

	/**
	 * The default value of the '{@link #isLocale() <em>Locale</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #isLocale()
	 * @generated
	 * @ordered
	 */
	protected static final boolean LOCALE_EDEFAULT = true;

	/**
	 * The cached value of the '{@link #isLocale() <em>Locale</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #isLocale()
	 * @generated
	 * @ordered
	 */
	protected boolean locale = LOCALE_EDEFAULT;

	/**
	 * The default value of the '{@link #getMaxFileSize() <em>Max File Size</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getMaxFileSize()
	 * @generated
	 * @ordered
	 */
	protected static final String MAX_FILE_SIZE_EDEFAULT = null;

	/**
	 * The cached value of the '{@link #getMaxFileSize() <em>Max File Size</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getMaxFileSize()
	 * @generated
	 * @ordered
	 */
	protected String maxFileSize = MAX_FILE_SIZE_EDEFAULT;

	/**
	 * The default value of the '{@link #getMemFileSize() <em>Mem File Size</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getMemFileSize()
	 * @generated
	 * @ordered
	 */
	protected static final String MEM_FILE_SIZE_EDEFAULT = null;

	/**
	 * The cached value of the '{@link #getMemFileSize() <em>Mem File Size</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getMemFileSize()
	 * @generated
	 * @ordered
	 */
	protected String memFileSize = MEM_FILE_SIZE_EDEFAULT;

	/**
	 * The default value of the '{@link #getMultipartClass() <em>Multipart Class</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getMultipartClass()
	 * @generated
	 * @ordered
	 */
	protected static final String MULTIPART_CLASS_EDEFAULT = null;

	/**
	 * The cached value of the '{@link #getMultipartClass() <em>Multipart Class</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getMultipartClass()
	 * @generated
	 * @ordered
	 */
	protected String multipartClass = MULTIPART_CLASS_EDEFAULT;

	/**
	 * The default value of the '{@link #isNocache() <em>Nocache</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #isNocache()
	 * @generated
	 * @ordered
	 */
	protected static final boolean NOCACHE_EDEFAULT = false;

	/**
	 * The cached value of the '{@link #isNocache() <em>Nocache</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #isNocache()
	 * @generated
	 * @ordered
	 */
	protected boolean nocache = NOCACHE_EDEFAULT;

	/**
	 * The default value of the '{@link #getPagePattern() <em>Page Pattern</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getPagePattern()
	 * @generated
	 * @ordered
	 */
	protected static final String PAGE_PATTERN_EDEFAULT = null;

	/**
	 * The cached value of the '{@link #getPagePattern() <em>Page Pattern</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getPagePattern()
	 * @generated
	 * @ordered
	 */
	protected String pagePattern = PAGE_PATTERN_EDEFAULT;

	/**
	 * The default value of the '{@link #getProcessorClass() <em>Processor Class</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getProcessorClass()
	 * @generated
	 * @ordered
	 */
	protected static final String PROCESSOR_CLASS_EDEFAULT = null;

	/**
	 * The cached value of the '{@link #getProcessorClass() <em>Processor Class</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getProcessorClass()
	 * @generated
	 * @ordered
	 */
	protected String processorClass = PROCESSOR_CLASS_EDEFAULT;

	/**
	 * The default value of the '{@link #getTempDir() <em>Temp Dir</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getTempDir()
	 * @generated
	 * @ordered
	 */
	protected static final String TEMP_DIR_EDEFAULT = null;

	/**
	 * The cached value of the '{@link #getTempDir() <em>Temp Dir</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getTempDir()
	 * @generated
	 * @ordered
	 */
	protected String tempDir = TEMP_DIR_EDEFAULT;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected ControllerTypeImpl() {
		super();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected EClass eStaticClass() {
		return StrutsConfigPackage.eINSTANCE.getControllerType();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public String getId() {
		return id;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setId(String newId) {
		String oldId = id;
		id = newId;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, StrutsConfigPackage.CONTROLLER_TYPE__ID, oldId, id));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public String getClassName() {
		return className;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setClassName(String newClassName) {
		String oldClassName = className;
		className = newClassName;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, StrutsConfigPackage.CONTROLLER_TYPE__CLASS_NAME, oldClassName, className));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public int getBufferSize() {
		return bufferSize;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setBufferSize(int newBufferSize) {
		int oldBufferSize = bufferSize;
		bufferSize = newBufferSize;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, StrutsConfigPackage.CONTROLLER_TYPE__BUFFER_SIZE, oldBufferSize, bufferSize));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public String getContentType() {
		return contentType;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setContentType(String newContentType) {
		String oldContentType = contentType;
		contentType = newContentType;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, StrutsConfigPackage.CONTROLLER_TYPE__CONTENT_TYPE, oldContentType, contentType));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public String getForwardPattern() {
		return forwardPattern;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setForwardPattern(String newForwardPattern) {
		String oldForwardPattern = forwardPattern;
		forwardPattern = newForwardPattern;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, StrutsConfigPackage.CONTROLLER_TYPE__FORWARD_PATTERN, oldForwardPattern, forwardPattern));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public boolean isInputForward() {
		return inputForward;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setInputForward(boolean newInputForward) {
		boolean oldInputForward = inputForward;
		inputForward = newInputForward;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, StrutsConfigPackage.CONTROLLER_TYPE__INPUT_FORWARD, oldInputForward, inputForward));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public boolean isLocale() {
		return locale;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setLocale(boolean newLocale) {
		boolean oldLocale = locale;
		locale = newLocale;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, StrutsConfigPackage.CONTROLLER_TYPE__LOCALE, oldLocale, locale));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public String getMaxFileSize() {
		return maxFileSize;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setMaxFileSize(String newMaxFileSize) {
		String oldMaxFileSize = maxFileSize;
		maxFileSize = newMaxFileSize;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, StrutsConfigPackage.CONTROLLER_TYPE__MAX_FILE_SIZE, oldMaxFileSize, maxFileSize));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public String getMemFileSize() {
		return memFileSize;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setMemFileSize(String newMemFileSize) {
		String oldMemFileSize = memFileSize;
		memFileSize = newMemFileSize;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, StrutsConfigPackage.CONTROLLER_TYPE__MEM_FILE_SIZE, oldMemFileSize, memFileSize));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public String getMultipartClass() {
		return multipartClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setMultipartClass(String newMultipartClass) {
		String oldMultipartClass = multipartClass;
		multipartClass = newMultipartClass;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, StrutsConfigPackage.CONTROLLER_TYPE__MULTIPART_CLASS, oldMultipartClass, multipartClass));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public boolean isNocache() {
		return nocache;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setNocache(boolean newNocache) {
		boolean oldNocache = nocache;
		nocache = newNocache;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, StrutsConfigPackage.CONTROLLER_TYPE__NOCACHE, oldNocache, nocache));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public String getPagePattern() {
		return pagePattern;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setPagePattern(String newPagePattern) {
		String oldPagePattern = pagePattern;
		pagePattern = newPagePattern;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, StrutsConfigPackage.CONTROLLER_TYPE__PAGE_PATTERN, oldPagePattern, pagePattern));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public String getProcessorClass() {
		return processorClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setProcessorClass(String newProcessorClass) {
		String oldProcessorClass = processorClass;
		processorClass = newProcessorClass;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, StrutsConfigPackage.CONTROLLER_TYPE__PROCESSOR_CLASS, oldProcessorClass, processorClass));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public String getTempDir() {
		return tempDir;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setTempDir(String newTempDir) {
		String oldTempDir = tempDir;
		tempDir = newTempDir;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, StrutsConfigPackage.CONTROLLER_TYPE__TEMP_DIR, oldTempDir, tempDir));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public NotificationChain eInverseRemove(InternalEObject otherEnd, int featureID, Class baseClass, NotificationChain msgs) {
		if (featureID >= 0) {
			switch (eDerivedStructuralFeatureID(featureID, baseClass)) {
				case StrutsConfigPackage.CONTROLLER_TYPE__SET_PROPERTY:
					return ((InternalEList)getSetProperty()).basicRemove(otherEnd, msgs);
				default:
					return eDynamicInverseRemove(otherEnd, featureID, baseClass, msgs);
			}
		}
		return eBasicSetContainer(null, featureID, msgs);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public Object eGet(EStructuralFeature eFeature, boolean resolve) {
		switch (eDerivedStructuralFeatureID(eFeature)) {
			case StrutsConfigPackage.CONTROLLER_TYPE__SET_PROPERTY:
				return getSetProperty();
			case StrutsConfigPackage.CONTROLLER_TYPE__ID:
				return getId();
			case StrutsConfigPackage.CONTROLLER_TYPE__CLASS_NAME:
				return getClassName();
			case StrutsConfigPackage.CONTROLLER_TYPE__BUFFER_SIZE:
				return new Integer(getBufferSize());
			case StrutsConfigPackage.CONTROLLER_TYPE__CONTENT_TYPE:
				return getContentType();
			case StrutsConfigPackage.CONTROLLER_TYPE__FORWARD_PATTERN:
				return getForwardPattern();
			case StrutsConfigPackage.CONTROLLER_TYPE__INPUT_FORWARD:
				return isInputForward() ? Boolean.TRUE : Boolean.FALSE;
			case StrutsConfigPackage.CONTROLLER_TYPE__LOCALE:
				return isLocale() ? Boolean.TRUE : Boolean.FALSE;
			case StrutsConfigPackage.CONTROLLER_TYPE__MAX_FILE_SIZE:
				return getMaxFileSize();
			case StrutsConfigPackage.CONTROLLER_TYPE__MEM_FILE_SIZE:
				return getMemFileSize();
			case StrutsConfigPackage.CONTROLLER_TYPE__MULTIPART_CLASS:
				return getMultipartClass();
			case StrutsConfigPackage.CONTROLLER_TYPE__NOCACHE:
				return isNocache() ? Boolean.TRUE : Boolean.FALSE;
			case StrutsConfigPackage.CONTROLLER_TYPE__PAGE_PATTERN:
				return getPagePattern();
			case StrutsConfigPackage.CONTROLLER_TYPE__PROCESSOR_CLASS:
				return getProcessorClass();
			case StrutsConfigPackage.CONTROLLER_TYPE__TEMP_DIR:
				return getTempDir();
		}
		return eDynamicGet(eFeature, resolve);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void eSet(EStructuralFeature eFeature, Object newValue) {
		switch (eDerivedStructuralFeatureID(eFeature)) {
			case StrutsConfigPackage.CONTROLLER_TYPE__SET_PROPERTY:
				getSetProperty().clear();
				getSetProperty().addAll((Collection)newValue);
				return;
			case StrutsConfigPackage.CONTROLLER_TYPE__ID:
				setId((String)newValue);
				return;
			case StrutsConfigPackage.CONTROLLER_TYPE__CLASS_NAME:
				setClassName((String)newValue);
				return;
			case StrutsConfigPackage.CONTROLLER_TYPE__BUFFER_SIZE:
				setBufferSize(((Integer)newValue).intValue());
				return;
			case StrutsConfigPackage.CONTROLLER_TYPE__CONTENT_TYPE:
				setContentType((String)newValue);
				return;
			case StrutsConfigPackage.CONTROLLER_TYPE__FORWARD_PATTERN:
				setForwardPattern((String)newValue);
				return;
			case StrutsConfigPackage.CONTROLLER_TYPE__INPUT_FORWARD:
				setInputForward(((Boolean)newValue).booleanValue());
				return;
			case StrutsConfigPackage.CONTROLLER_TYPE__LOCALE:
				setLocale(((Boolean)newValue).booleanValue());
				return;
			case StrutsConfigPackage.CONTROLLER_TYPE__MAX_FILE_SIZE:
				setMaxFileSize((String)newValue);
				return;
			case StrutsConfigPackage.CONTROLLER_TYPE__MEM_FILE_SIZE:
				setMemFileSize((String)newValue);
				return;
			case StrutsConfigPackage.CONTROLLER_TYPE__MULTIPART_CLASS:
				setMultipartClass((String)newValue);
				return;
			case StrutsConfigPackage.CONTROLLER_TYPE__NOCACHE:
				setNocache(((Boolean)newValue).booleanValue());
				return;
			case StrutsConfigPackage.CONTROLLER_TYPE__PAGE_PATTERN:
				setPagePattern((String)newValue);
				return;
			case StrutsConfigPackage.CONTROLLER_TYPE__PROCESSOR_CLASS:
				setProcessorClass((String)newValue);
				return;
			case StrutsConfigPackage.CONTROLLER_TYPE__TEMP_DIR:
				setTempDir((String)newValue);
				return;
		}
		eDynamicSet(eFeature, newValue);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void eUnset(EStructuralFeature eFeature) {
		switch (eDerivedStructuralFeatureID(eFeature)) {
			case StrutsConfigPackage.CONTROLLER_TYPE__SET_PROPERTY:
				getSetProperty().clear();
				return;
			case StrutsConfigPackage.CONTROLLER_TYPE__ID:
				setId(ID_EDEFAULT);
				return;
			case StrutsConfigPackage.CONTROLLER_TYPE__CLASS_NAME:
				setClassName(CLASS_NAME_EDEFAULT);
				return;
			case StrutsConfigPackage.CONTROLLER_TYPE__BUFFER_SIZE:
				setBufferSize(BUFFER_SIZE_EDEFAULT);
				return;
			case StrutsConfigPackage.CONTROLLER_TYPE__CONTENT_TYPE:
				setContentType(CONTENT_TYPE_EDEFAULT);
				return;
			case StrutsConfigPackage.CONTROLLER_TYPE__FORWARD_PATTERN:
				setForwardPattern(FORWARD_PATTERN_EDEFAULT);
				return;
			case StrutsConfigPackage.CONTROLLER_TYPE__INPUT_FORWARD:
				setInputForward(INPUT_FORWARD_EDEFAULT);
				return;
			case StrutsConfigPackage.CONTROLLER_TYPE__LOCALE:
				setLocale(LOCALE_EDEFAULT);
				return;
			case StrutsConfigPackage.CONTROLLER_TYPE__MAX_FILE_SIZE:
				setMaxFileSize(MAX_FILE_SIZE_EDEFAULT);
				return;
			case StrutsConfigPackage.CONTROLLER_TYPE__MEM_FILE_SIZE:
				setMemFileSize(MEM_FILE_SIZE_EDEFAULT);
				return;
			case StrutsConfigPackage.CONTROLLER_TYPE__MULTIPART_CLASS:
				setMultipartClass(MULTIPART_CLASS_EDEFAULT);
				return;
			case StrutsConfigPackage.CONTROLLER_TYPE__NOCACHE:
				setNocache(NOCACHE_EDEFAULT);
				return;
			case StrutsConfigPackage.CONTROLLER_TYPE__PAGE_PATTERN:
				setPagePattern(PAGE_PATTERN_EDEFAULT);
				return;
			case StrutsConfigPackage.CONTROLLER_TYPE__PROCESSOR_CLASS:
				setProcessorClass(PROCESSOR_CLASS_EDEFAULT);
				return;
			case StrutsConfigPackage.CONTROLLER_TYPE__TEMP_DIR:
				setTempDir(TEMP_DIR_EDEFAULT);
				return;
		}
		eDynamicUnset(eFeature);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public boolean eIsSet(EStructuralFeature eFeature) {
		switch (eDerivedStructuralFeatureID(eFeature)) {
			case StrutsConfigPackage.CONTROLLER_TYPE__SET_PROPERTY:
				return setProperty != null && !setProperty.isEmpty();
			case StrutsConfigPackage.CONTROLLER_TYPE__ID:
				return ID_EDEFAULT == null ? id != null : !ID_EDEFAULT.equals(id);
			case StrutsConfigPackage.CONTROLLER_TYPE__CLASS_NAME:
				return CLASS_NAME_EDEFAULT == null ? className != null : !CLASS_NAME_EDEFAULT.equals(className);
			case StrutsConfigPackage.CONTROLLER_TYPE__BUFFER_SIZE:
				return bufferSize != BUFFER_SIZE_EDEFAULT;
			case StrutsConfigPackage.CONTROLLER_TYPE__CONTENT_TYPE:
				return CONTENT_TYPE_EDEFAULT == null ? contentType != null : !CONTENT_TYPE_EDEFAULT.equals(contentType);
			case StrutsConfigPackage.CONTROLLER_TYPE__FORWARD_PATTERN:
				return FORWARD_PATTERN_EDEFAULT == null ? forwardPattern != null : !FORWARD_PATTERN_EDEFAULT.equals(forwardPattern);
			case StrutsConfigPackage.CONTROLLER_TYPE__INPUT_FORWARD:
				return inputForward != INPUT_FORWARD_EDEFAULT;
			case StrutsConfigPackage.CONTROLLER_TYPE__LOCALE:
				return locale != LOCALE_EDEFAULT;
			case StrutsConfigPackage.CONTROLLER_TYPE__MAX_FILE_SIZE:
				return MAX_FILE_SIZE_EDEFAULT == null ? maxFileSize != null : !MAX_FILE_SIZE_EDEFAULT.equals(maxFileSize);
			case StrutsConfigPackage.CONTROLLER_TYPE__MEM_FILE_SIZE:
				return MEM_FILE_SIZE_EDEFAULT == null ? memFileSize != null : !MEM_FILE_SIZE_EDEFAULT.equals(memFileSize);
			case StrutsConfigPackage.CONTROLLER_TYPE__MULTIPART_CLASS:
				return MULTIPART_CLASS_EDEFAULT == null ? multipartClass != null : !MULTIPART_CLASS_EDEFAULT.equals(multipartClass);
			case StrutsConfigPackage.CONTROLLER_TYPE__NOCACHE:
				return nocache != NOCACHE_EDEFAULT;
			case StrutsConfigPackage.CONTROLLER_TYPE__PAGE_PATTERN:
				return PAGE_PATTERN_EDEFAULT == null ? pagePattern != null : !PAGE_PATTERN_EDEFAULT.equals(pagePattern);
			case StrutsConfigPackage.CONTROLLER_TYPE__PROCESSOR_CLASS:
				return PROCESSOR_CLASS_EDEFAULT == null ? processorClass != null : !PROCESSOR_CLASS_EDEFAULT.equals(processorClass);
			case StrutsConfigPackage.CONTROLLER_TYPE__TEMP_DIR:
				return TEMP_DIR_EDEFAULT == null ? tempDir != null : !TEMP_DIR_EDEFAULT.equals(tempDir);
		}
		return eDynamicIsSet(eFeature);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public String toString() {
		if (eIsProxy()) return super.toString();

		StringBuffer result = new StringBuffer(super.toString());
		result.append(" (id: "); //$NON-NLS-1$
		result.append(id);
		result.append(", className: "); //$NON-NLS-1$
		result.append(className);
		result.append(", bufferSize: "); //$NON-NLS-1$
		result.append(bufferSize);
		result.append(", contentType: "); //$NON-NLS-1$
		result.append(contentType);
		result.append(", forwardPattern: "); //$NON-NLS-1$
		result.append(forwardPattern);
		result.append(", inputForward: "); //$NON-NLS-1$
		result.append(inputForward);
		result.append(", locale: "); //$NON-NLS-1$
		result.append(locale);
		result.append(", maxFileSize: "); //$NON-NLS-1$
		result.append(maxFileSize);
		result.append(", memFileSize: "); //$NON-NLS-1$
		result.append(memFileSize);
		result.append(", multipartClass: "); //$NON-NLS-1$
		result.append(multipartClass);
		result.append(", nocache: "); //$NON-NLS-1$
		result.append(nocache);
		result.append(", pagePattern: "); //$NON-NLS-1$
		result.append(pagePattern);
		result.append(", processorClass: "); //$NON-NLS-1$
		result.append(processorClass);
		result.append(", tempDir: "); //$NON-NLS-1$
		result.append(tempDir);
		result.append(')');
		return result.toString();
	}

} //ControllerTypeImpl
