/**
 * <copyright>
 * </copyright>
 *
 * $Id: FormBeanTypeImpl.java,v 1.3 2005/07/21 15:21:00 daniel_rohe Exp $
 */
package de.strutsbox.strutsconfig.impl;

import de.strutsbox.strutsconfig.FormBeanType;
import de.strutsbox.strutsconfig.FormPropertyType;
import de.strutsbox.strutsconfig.StrutsConfigPackage;
import de.strutsbox.strutsconfig.Visualizable;

import java.util.Collection;

import org.eclipse.emf.common.notify.Notification;
import org.eclipse.emf.common.notify.NotificationChain;

import org.eclipse.emf.common.util.EList;

import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.EStructuralFeature;
import org.eclipse.emf.ecore.InternalEObject;

import org.eclipse.emf.ecore.impl.ENotificationImpl;

import org.eclipse.emf.ecore.util.EObjectContainmentEList;
import org.eclipse.emf.ecore.util.InternalEList;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model object '<em><b>Form Bean Type</b></em>'.
 * <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * <ul>
 *   <li>{@link de.strutsbox.strutsconfig.impl.FormBeanTypeImpl#getDisplayName <em>Display Name</em>}</li>
 *   <li>{@link de.strutsbox.strutsconfig.impl.FormBeanTypeImpl#getDescription <em>Description</em>}</li>
 *   <li>{@link de.strutsbox.strutsconfig.impl.FormBeanTypeImpl#getSmallIcon <em>Small Icon</em>}</li>
 *   <li>{@link de.strutsbox.strutsconfig.impl.FormBeanTypeImpl#getLargeIcon <em>Large Icon</em>}</li>
 *   <li>{@link de.strutsbox.strutsconfig.impl.FormBeanTypeImpl#getId <em>Id</em>}</li>
 *   <li>{@link de.strutsbox.strutsconfig.impl.FormBeanTypeImpl#getClassName <em>Class Name</em>}</li>
 *   <li>{@link de.strutsbox.strutsconfig.impl.FormBeanTypeImpl#getName <em>Name</em>}</li>
 *   <li>{@link de.strutsbox.strutsconfig.impl.FormBeanTypeImpl#getType <em>Type</em>}</li>
 *   <li>{@link de.strutsbox.strutsconfig.impl.FormBeanTypeImpl#isDynamic <em>Dynamic</em>}</li>
 *   <li>{@link de.strutsbox.strutsconfig.impl.FormBeanTypeImpl#getFormProperty <em>Form Property</em>}</li>
 * </ul>
 * </p>
 *
 * @generated
 */
public class FormBeanTypeImpl extends ConfigurableImpl implements FormBeanType {
	/**
	 * The default value of the '{@link #getDisplayName() <em>Display Name</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getDisplayName()
	 * @generated
	 * @ordered
	 */
	protected static final String DISPLAY_NAME_EDEFAULT = null;

	/**
	 * The cached value of the '{@link #getDisplayName() <em>Display Name</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getDisplayName()
	 * @generated
	 * @ordered
	 */
	protected String displayName = DISPLAY_NAME_EDEFAULT;

	/**
	 * The default value of the '{@link #getDescription() <em>Description</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getDescription()
	 * @generated
	 * @ordered
	 */
	protected static final String DESCRIPTION_EDEFAULT = null;

	/**
	 * The cached value of the '{@link #getDescription() <em>Description</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getDescription()
	 * @generated
	 * @ordered
	 */
	protected String description = DESCRIPTION_EDEFAULT;

	/**
	 * The default value of the '{@link #getSmallIcon() <em>Small Icon</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getSmallIcon()
	 * @generated
	 * @ordered
	 */
	protected static final String SMALL_ICON_EDEFAULT = null;

	/**
	 * The cached value of the '{@link #getSmallIcon() <em>Small Icon</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getSmallIcon()
	 * @generated
	 * @ordered
	 */
	protected String smallIcon = SMALL_ICON_EDEFAULT;

	/**
	 * The default value of the '{@link #getLargeIcon() <em>Large Icon</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getLargeIcon()
	 * @generated
	 * @ordered
	 */
	protected static final String LARGE_ICON_EDEFAULT = null;

	/**
	 * The cached value of the '{@link #getLargeIcon() <em>Large Icon</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getLargeIcon()
	 * @generated
	 * @ordered
	 */
	protected String largeIcon = LARGE_ICON_EDEFAULT;

	/**
	 * The default value of the '{@link #getId() <em>Id</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getId()
	 * @generated
	 * @ordered
	 */
	protected static final String ID_EDEFAULT = null;

	/**
	 * The cached value of the '{@link #getId() <em>Id</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getId()
	 * @generated
	 * @ordered
	 */
	protected String id = ID_EDEFAULT;

	/**
	 * The default value of the '{@link #getClassName() <em>Class Name</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getClassName()
	 * @generated
	 * @ordered
	 */
	protected static final String CLASS_NAME_EDEFAULT = null;

	/**
	 * The cached value of the '{@link #getClassName() <em>Class Name</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getClassName()
	 * @generated
	 * @ordered
	 */
	protected String className = CLASS_NAME_EDEFAULT;

	/**
	 * The default value of the '{@link #getName() <em>Name</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getName()
	 * @generated
	 * @ordered
	 */
	protected static final String NAME_EDEFAULT = null;

	/**
	 * The cached value of the '{@link #getName() <em>Name</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getName()
	 * @generated
	 * @ordered
	 */
	protected String name = NAME_EDEFAULT;

	/**
	 * The default value of the '{@link #getType() <em>Type</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getType()
	 * @generated
	 * @ordered
	 */
	protected static final String TYPE_EDEFAULT = null;

	/**
	 * The cached value of the '{@link #getType() <em>Type</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getType()
	 * @generated
	 * @ordered
	 */
	protected String type = TYPE_EDEFAULT;

	/**
	 * The default value of the '{@link #isDynamic() <em>Dynamic</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #isDynamic()
	 * @generated
	 * @ordered
	 */
	protected static final boolean DYNAMIC_EDEFAULT = false;

	/**
	 * The cached value of the '{@link #isDynamic() <em>Dynamic</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #isDynamic()
	 * @generated
	 * @ordered
	 */
	protected boolean dynamic = DYNAMIC_EDEFAULT;

	/**
	 * The cached value of the '{@link #getFormProperty() <em>Form Property</em>}' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getFormProperty()
	 * @generated
	 * @ordered
	 */
	protected EList formProperty = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected FormBeanTypeImpl() {
		super();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected EClass eStaticClass() {
		return StrutsConfigPackage.eINSTANCE.getFormBeanType();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public String getDisplayName() {
		return displayName;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setDisplayName(String newDisplayName) {
		String oldDisplayName = displayName;
		displayName = newDisplayName;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, StrutsConfigPackage.FORM_BEAN_TYPE__DISPLAY_NAME, oldDisplayName, displayName));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public String getDescription() {
		return description;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setDescription(String newDescription) {
		String oldDescription = description;
		description = newDescription;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, StrutsConfigPackage.FORM_BEAN_TYPE__DESCRIPTION, oldDescription, description));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public String getSmallIcon() {
		return smallIcon;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setSmallIcon(String newSmallIcon) {
		String oldSmallIcon = smallIcon;
		smallIcon = newSmallIcon;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, StrutsConfigPackage.FORM_BEAN_TYPE__SMALL_ICON, oldSmallIcon, smallIcon));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public String getLargeIcon() {
		return largeIcon;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setLargeIcon(String newLargeIcon) {
		String oldLargeIcon = largeIcon;
		largeIcon = newLargeIcon;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, StrutsConfigPackage.FORM_BEAN_TYPE__LARGE_ICON, oldLargeIcon, largeIcon));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public String getId() {
		return id;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setId(String newId) {
		String oldId = id;
		id = newId;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, StrutsConfigPackage.FORM_BEAN_TYPE__ID, oldId, id));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public String getClassName() {
		return className;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setClassName(String newClassName) {
		String oldClassName = className;
		className = newClassName;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, StrutsConfigPackage.FORM_BEAN_TYPE__CLASS_NAME, oldClassName, className));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public String getName() {
		return name;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setName(String newName) {
		String oldName = name;
		name = newName;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, StrutsConfigPackage.FORM_BEAN_TYPE__NAME, oldName, name));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public String getType() {
		return type;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setType(String newType) {
		String oldType = type;
		type = newType;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, StrutsConfigPackage.FORM_BEAN_TYPE__TYPE, oldType, type));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public boolean isDynamic() {
		return dynamic;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setDynamic(boolean newDynamic) {
		boolean oldDynamic = dynamic;
		dynamic = newDynamic;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, StrutsConfigPackage.FORM_BEAN_TYPE__DYNAMIC, oldDynamic, dynamic));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EList getFormProperty() {
		if (formProperty == null) {
			formProperty = new EObjectContainmentEList(FormPropertyType.class, this, StrutsConfigPackage.FORM_BEAN_TYPE__FORM_PROPERTY);
		}
		return formProperty;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public NotificationChain eInverseRemove(InternalEObject otherEnd, int featureID, Class baseClass, NotificationChain msgs) {
		if (featureID >= 0) {
			switch (eDerivedStructuralFeatureID(featureID, baseClass)) {
				case StrutsConfigPackage.FORM_BEAN_TYPE__SET_PROPERTY:
					return ((InternalEList)getSetProperty()).basicRemove(otherEnd, msgs);
				case StrutsConfigPackage.FORM_BEAN_TYPE__FORM_PROPERTY:
					return ((InternalEList)getFormProperty()).basicRemove(otherEnd, msgs);
				default:
					return eDynamicInverseRemove(otherEnd, featureID, baseClass, msgs);
			}
		}
		return eBasicSetContainer(null, featureID, msgs);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public Object eGet(EStructuralFeature eFeature, boolean resolve) {
		switch (eDerivedStructuralFeatureID(eFeature)) {
			case StrutsConfigPackage.FORM_BEAN_TYPE__SET_PROPERTY:
				return getSetProperty();
			case StrutsConfigPackage.FORM_BEAN_TYPE__DISPLAY_NAME:
				return getDisplayName();
			case StrutsConfigPackage.FORM_BEAN_TYPE__DESCRIPTION:
				return getDescription();
			case StrutsConfigPackage.FORM_BEAN_TYPE__SMALL_ICON:
				return getSmallIcon();
			case StrutsConfigPackage.FORM_BEAN_TYPE__LARGE_ICON:
				return getLargeIcon();
			case StrutsConfigPackage.FORM_BEAN_TYPE__ID:
				return getId();
			case StrutsConfigPackage.FORM_BEAN_TYPE__CLASS_NAME:
				return getClassName();
			case StrutsConfigPackage.FORM_BEAN_TYPE__NAME:
				return getName();
			case StrutsConfigPackage.FORM_BEAN_TYPE__TYPE:
				return getType();
			case StrutsConfigPackage.FORM_BEAN_TYPE__DYNAMIC:
				return isDynamic() ? Boolean.TRUE : Boolean.FALSE;
			case StrutsConfigPackage.FORM_BEAN_TYPE__FORM_PROPERTY:
				return getFormProperty();
		}
		return eDynamicGet(eFeature, resolve);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void eSet(EStructuralFeature eFeature, Object newValue) {
		switch (eDerivedStructuralFeatureID(eFeature)) {
			case StrutsConfigPackage.FORM_BEAN_TYPE__SET_PROPERTY:
				getSetProperty().clear();
				getSetProperty().addAll((Collection)newValue);
				return;
			case StrutsConfigPackage.FORM_BEAN_TYPE__DISPLAY_NAME:
				setDisplayName((String)newValue);
				return;
			case StrutsConfigPackage.FORM_BEAN_TYPE__DESCRIPTION:
				setDescription((String)newValue);
				return;
			case StrutsConfigPackage.FORM_BEAN_TYPE__SMALL_ICON:
				setSmallIcon((String)newValue);
				return;
			case StrutsConfigPackage.FORM_BEAN_TYPE__LARGE_ICON:
				setLargeIcon((String)newValue);
				return;
			case StrutsConfigPackage.FORM_BEAN_TYPE__ID:
				setId((String)newValue);
				return;
			case StrutsConfigPackage.FORM_BEAN_TYPE__CLASS_NAME:
				setClassName((String)newValue);
				return;
			case StrutsConfigPackage.FORM_BEAN_TYPE__NAME:
				setName((String)newValue);
				return;
			case StrutsConfigPackage.FORM_BEAN_TYPE__TYPE:
				setType((String)newValue);
				return;
			case StrutsConfigPackage.FORM_BEAN_TYPE__DYNAMIC:
				setDynamic(((Boolean)newValue).booleanValue());
				return;
			case StrutsConfigPackage.FORM_BEAN_TYPE__FORM_PROPERTY:
				getFormProperty().clear();
				getFormProperty().addAll((Collection)newValue);
				return;
		}
		eDynamicSet(eFeature, newValue);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void eUnset(EStructuralFeature eFeature) {
		switch (eDerivedStructuralFeatureID(eFeature)) {
			case StrutsConfigPackage.FORM_BEAN_TYPE__SET_PROPERTY:
				getSetProperty().clear();
				return;
			case StrutsConfigPackage.FORM_BEAN_TYPE__DISPLAY_NAME:
				setDisplayName(DISPLAY_NAME_EDEFAULT);
				return;
			case StrutsConfigPackage.FORM_BEAN_TYPE__DESCRIPTION:
				setDescription(DESCRIPTION_EDEFAULT);
				return;
			case StrutsConfigPackage.FORM_BEAN_TYPE__SMALL_ICON:
				setSmallIcon(SMALL_ICON_EDEFAULT);
				return;
			case StrutsConfigPackage.FORM_BEAN_TYPE__LARGE_ICON:
				setLargeIcon(LARGE_ICON_EDEFAULT);
				return;
			case StrutsConfigPackage.FORM_BEAN_TYPE__ID:
				setId(ID_EDEFAULT);
				return;
			case StrutsConfigPackage.FORM_BEAN_TYPE__CLASS_NAME:
				setClassName(CLASS_NAME_EDEFAULT);
				return;
			case StrutsConfigPackage.FORM_BEAN_TYPE__NAME:
				setName(NAME_EDEFAULT);
				return;
			case StrutsConfigPackage.FORM_BEAN_TYPE__TYPE:
				setType(TYPE_EDEFAULT);
				return;
			case StrutsConfigPackage.FORM_BEAN_TYPE__DYNAMIC:
				setDynamic(DYNAMIC_EDEFAULT);
				return;
			case StrutsConfigPackage.FORM_BEAN_TYPE__FORM_PROPERTY:
				getFormProperty().clear();
				return;
		}
		eDynamicUnset(eFeature);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public boolean eIsSet(EStructuralFeature eFeature) {
		switch (eDerivedStructuralFeatureID(eFeature)) {
			case StrutsConfigPackage.FORM_BEAN_TYPE__SET_PROPERTY:
				return setProperty != null && !setProperty.isEmpty();
			case StrutsConfigPackage.FORM_BEAN_TYPE__DISPLAY_NAME:
				return DISPLAY_NAME_EDEFAULT == null ? displayName != null : !DISPLAY_NAME_EDEFAULT.equals(displayName);
			case StrutsConfigPackage.FORM_BEAN_TYPE__DESCRIPTION:
				return DESCRIPTION_EDEFAULT == null ? description != null : !DESCRIPTION_EDEFAULT.equals(description);
			case StrutsConfigPackage.FORM_BEAN_TYPE__SMALL_ICON:
				return SMALL_ICON_EDEFAULT == null ? smallIcon != null : !SMALL_ICON_EDEFAULT.equals(smallIcon);
			case StrutsConfigPackage.FORM_BEAN_TYPE__LARGE_ICON:
				return LARGE_ICON_EDEFAULT == null ? largeIcon != null : !LARGE_ICON_EDEFAULT.equals(largeIcon);
			case StrutsConfigPackage.FORM_BEAN_TYPE__ID:
				return ID_EDEFAULT == null ? id != null : !ID_EDEFAULT.equals(id);
			case StrutsConfigPackage.FORM_BEAN_TYPE__CLASS_NAME:
				return CLASS_NAME_EDEFAULT == null ? className != null : !CLASS_NAME_EDEFAULT.equals(className);
			case StrutsConfigPackage.FORM_BEAN_TYPE__NAME:
				return NAME_EDEFAULT == null ? name != null : !NAME_EDEFAULT.equals(name);
			case StrutsConfigPackage.FORM_BEAN_TYPE__TYPE:
				return TYPE_EDEFAULT == null ? type != null : !TYPE_EDEFAULT.equals(type);
			case StrutsConfigPackage.FORM_BEAN_TYPE__DYNAMIC:
				return dynamic != DYNAMIC_EDEFAULT;
			case StrutsConfigPackage.FORM_BEAN_TYPE__FORM_PROPERTY:
				return formProperty != null && !formProperty.isEmpty();
		}
		return eDynamicIsSet(eFeature);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public int eBaseStructuralFeatureID(int derivedFeatureID, Class baseClass) {
		if (baseClass == Visualizable.class) {
			switch (derivedFeatureID) {
				case StrutsConfigPackage.FORM_BEAN_TYPE__DISPLAY_NAME: return StrutsConfigPackage.VISUALIZABLE__DISPLAY_NAME;
				case StrutsConfigPackage.FORM_BEAN_TYPE__DESCRIPTION: return StrutsConfigPackage.VISUALIZABLE__DESCRIPTION;
				case StrutsConfigPackage.FORM_BEAN_TYPE__SMALL_ICON: return StrutsConfigPackage.VISUALIZABLE__SMALL_ICON;
				case StrutsConfigPackage.FORM_BEAN_TYPE__LARGE_ICON: return StrutsConfigPackage.VISUALIZABLE__LARGE_ICON;
				default: return -1;
			}
		}
		return super.eBaseStructuralFeatureID(derivedFeatureID, baseClass);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public int eDerivedStructuralFeatureID(int baseFeatureID, Class baseClass) {
		if (baseClass == Visualizable.class) {
			switch (baseFeatureID) {
				case StrutsConfigPackage.VISUALIZABLE__DISPLAY_NAME: return StrutsConfigPackage.FORM_BEAN_TYPE__DISPLAY_NAME;
				case StrutsConfigPackage.VISUALIZABLE__DESCRIPTION: return StrutsConfigPackage.FORM_BEAN_TYPE__DESCRIPTION;
				case StrutsConfigPackage.VISUALIZABLE__SMALL_ICON: return StrutsConfigPackage.FORM_BEAN_TYPE__SMALL_ICON;
				case StrutsConfigPackage.VISUALIZABLE__LARGE_ICON: return StrutsConfigPackage.FORM_BEAN_TYPE__LARGE_ICON;
				default: return -1;
			}
		}
		return super.eDerivedStructuralFeatureID(baseFeatureID, baseClass);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public String toString() {
		if (eIsProxy()) return super.toString();

		StringBuffer result = new StringBuffer(super.toString());
		result.append(" (displayName: "); //$NON-NLS-1$
		result.append(displayName);
		result.append(", description: "); //$NON-NLS-1$
		result.append(description);
		result.append(", smallIcon: "); //$NON-NLS-1$
		result.append(smallIcon);
		result.append(", largeIcon: "); //$NON-NLS-1$
		result.append(largeIcon);
		result.append(", id: "); //$NON-NLS-1$
		result.append(id);
		result.append(", className: "); //$NON-NLS-1$
		result.append(className);
		result.append(", name: "); //$NON-NLS-1$
		result.append(name);
		result.append(", type: "); //$NON-NLS-1$
		result.append(type);
		result.append(", dynamic: "); //$NON-NLS-1$
		result.append(dynamic);
		result.append(')');
		return result.toString();
	}

} //FormBeanTypeImpl
