/**
 * <copyright>
 * </copyright>
 *
 * $Id: StrutsConfigTypeImpl.java,v 1.3 2005/07/21 15:21:00 daniel_rohe Exp $
 */
package de.strutsbox.strutsconfig.impl;

import de.strutsbox.strutsconfig.ActionMappingsType;
import de.strutsbox.strutsconfig.ControllerType;
import de.strutsbox.strutsconfig.DataSourcesType;
import de.strutsbox.strutsconfig.FormBeansType;
import de.strutsbox.strutsconfig.GlobalExceptionsType;
import de.strutsbox.strutsconfig.GlobalForwardsType;
import de.strutsbox.strutsconfig.MessageResourcesType;
import de.strutsbox.strutsconfig.PlugInType;
import de.strutsbox.strutsconfig.StrutsConfigPackage;
import de.strutsbox.strutsconfig.StrutsConfigType;

import java.util.Collection;

import org.eclipse.emf.common.notify.Notification;
import org.eclipse.emf.common.notify.NotificationChain;

import org.eclipse.emf.common.util.EList;

import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.EStructuralFeature;
import org.eclipse.emf.ecore.InternalEObject;

import org.eclipse.emf.ecore.impl.ENotificationImpl;
import org.eclipse.emf.ecore.impl.EObjectImpl;

import org.eclipse.emf.ecore.util.EObjectContainmentEList;
import org.eclipse.emf.ecore.util.InternalEList;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model object '<em><b>Type</b></em>'.
 * <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * <ul>
 *   <li>{@link de.strutsbox.strutsconfig.impl.StrutsConfigTypeImpl#getId <em>Id</em>}</li>
 *   <li>{@link de.strutsbox.strutsconfig.impl.StrutsConfigTypeImpl#getVersion <em>Version</em>}</li>
 *   <li>{@link de.strutsbox.strutsconfig.impl.StrutsConfigTypeImpl#getDisplayName <em>Display Name</em>}</li>
 *   <li>{@link de.strutsbox.strutsconfig.impl.StrutsConfigTypeImpl#getDescription <em>Description</em>}</li>
 *   <li>{@link de.strutsbox.strutsconfig.impl.StrutsConfigTypeImpl#getDataSources <em>Data Sources</em>}</li>
 *   <li>{@link de.strutsbox.strutsconfig.impl.StrutsConfigTypeImpl#getFormBeans <em>Form Beans</em>}</li>
 *   <li>{@link de.strutsbox.strutsconfig.impl.StrutsConfigTypeImpl#getGlobalExceptions <em>Global Exceptions</em>}</li>
 *   <li>{@link de.strutsbox.strutsconfig.impl.StrutsConfigTypeImpl#getGlobalForwards <em>Global Forwards</em>}</li>
 *   <li>{@link de.strutsbox.strutsconfig.impl.StrutsConfigTypeImpl#getActionMappings <em>Action Mappings</em>}</li>
 *   <li>{@link de.strutsbox.strutsconfig.impl.StrutsConfigTypeImpl#getController <em>Controller</em>}</li>
 *   <li>{@link de.strutsbox.strutsconfig.impl.StrutsConfigTypeImpl#getMessageResources <em>Message Resources</em>}</li>
 *   <li>{@link de.strutsbox.strutsconfig.impl.StrutsConfigTypeImpl#getPlugIn <em>Plug In</em>}</li>
 * </ul>
 * </p>
 *
 * @generated
 */
public class StrutsConfigTypeImpl extends EObjectImpl implements StrutsConfigType {
	/**
	 * The default value of the '{@link #getId() <em>Id</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getId()
	 * @generated
	 * @ordered
	 */
	protected static final String ID_EDEFAULT = null;

	/**
	 * The cached value of the '{@link #getId() <em>Id</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getId()
	 * @generated
	 * @ordered
	 */
	protected String id = ID_EDEFAULT;

	/**
	 * The default value of the '{@link #getVersion() <em>Version</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getVersion()
	 * @generated
	 * @ordered
	 */
	protected static final String VERSION_EDEFAULT = null;

	/**
	 * The cached value of the '{@link #getVersion() <em>Version</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getVersion()
	 * @generated
	 * @ordered
	 */
	protected String version = VERSION_EDEFAULT;

	/**
	 * The default value of the '{@link #getDisplayName() <em>Display Name</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getDisplayName()
	 * @generated
	 * @ordered
	 */
	protected static final String DISPLAY_NAME_EDEFAULT = null;

	/**
	 * The cached value of the '{@link #getDisplayName() <em>Display Name</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getDisplayName()
	 * @generated
	 * @ordered
	 */
	protected String displayName = DISPLAY_NAME_EDEFAULT;

	/**
	 * The default value of the '{@link #getDescription() <em>Description</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getDescription()
	 * @generated
	 * @ordered
	 */
	protected static final String DESCRIPTION_EDEFAULT = null;

	/**
	 * The cached value of the '{@link #getDescription() <em>Description</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getDescription()
	 * @generated
	 * @ordered
	 */
	protected String description = DESCRIPTION_EDEFAULT;

	/**
	 * The cached value of the '{@link #getDataSources() <em>Data Sources</em>}' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getDataSources()
	 * @generated
	 * @ordered
	 */
	protected DataSourcesType dataSources = null;

	/**
	 * The cached value of the '{@link #getFormBeans() <em>Form Beans</em>}' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getFormBeans()
	 * @generated
	 * @ordered
	 */
	protected FormBeansType formBeans = null;

	/**
	 * The cached value of the '{@link #getGlobalExceptions() <em>Global Exceptions</em>}' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getGlobalExceptions()
	 * @generated
	 * @ordered
	 */
	protected GlobalExceptionsType globalExceptions = null;

	/**
	 * The cached value of the '{@link #getGlobalForwards() <em>Global Forwards</em>}' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getGlobalForwards()
	 * @generated
	 * @ordered
	 */
	protected GlobalForwardsType globalForwards = null;

	/**
	 * The cached value of the '{@link #getActionMappings() <em>Action Mappings</em>}' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getActionMappings()
	 * @generated
	 * @ordered
	 */
	protected ActionMappingsType actionMappings = null;

	/**
	 * The cached value of the '{@link #getController() <em>Controller</em>}' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getController()
	 * @generated
	 * @ordered
	 */
	protected ControllerType controller = null;

	/**
	 * The cached value of the '{@link #getMessageResources() <em>Message Resources</em>}' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getMessageResources()
	 * @generated
	 * @ordered
	 */
	protected EList messageResources = null;

	/**
	 * The cached value of the '{@link #getPlugIn() <em>Plug In</em>}' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getPlugIn()
	 * @generated
	 * @ordered
	 */
	protected EList plugIn = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected StrutsConfigTypeImpl() {
		super();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected EClass eStaticClass() {
		return StrutsConfigPackage.eINSTANCE.getStrutsConfigType();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public String getId() {
		return id;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setId(String newId) {
		String oldId = id;
		id = newId;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, StrutsConfigPackage.STRUTS_CONFIG_TYPE__ID, oldId, id));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public String getVersion() {
		return version;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setVersion(String newVersion) {
		String oldVersion = version;
		version = newVersion;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, StrutsConfigPackage.STRUTS_CONFIG_TYPE__VERSION, oldVersion, version));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public String getDisplayName() {
		return displayName;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setDisplayName(String newDisplayName) {
		String oldDisplayName = displayName;
		displayName = newDisplayName;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, StrutsConfigPackage.STRUTS_CONFIG_TYPE__DISPLAY_NAME, oldDisplayName, displayName));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public String getDescription() {
		return description;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setDescription(String newDescription) {
		String oldDescription = description;
		description = newDescription;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, StrutsConfigPackage.STRUTS_CONFIG_TYPE__DESCRIPTION, oldDescription, description));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public DataSourcesType getDataSources() {
		return dataSources;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public NotificationChain basicSetDataSources(DataSourcesType newDataSources, NotificationChain msgs) {
		DataSourcesType oldDataSources = dataSources;
		dataSources = newDataSources;
		if (eNotificationRequired()) {
			ENotificationImpl notification = new ENotificationImpl(this, Notification.SET, StrutsConfigPackage.STRUTS_CONFIG_TYPE__DATA_SOURCES, oldDataSources, newDataSources);
			if (msgs == null) msgs = notification; else msgs.add(notification);
		}
		return msgs;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setDataSources(DataSourcesType newDataSources) {
		if (newDataSources != dataSources) {
			NotificationChain msgs = null;
			if (dataSources != null)
				msgs = ((InternalEObject)dataSources).eInverseRemove(this, EOPPOSITE_FEATURE_BASE - StrutsConfigPackage.STRUTS_CONFIG_TYPE__DATA_SOURCES, null, msgs);
			if (newDataSources != null)
				msgs = ((InternalEObject)newDataSources).eInverseAdd(this, EOPPOSITE_FEATURE_BASE - StrutsConfigPackage.STRUTS_CONFIG_TYPE__DATA_SOURCES, null, msgs);
			msgs = basicSetDataSources(newDataSources, msgs);
			if (msgs != null) msgs.dispatch();
		}
		else if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, StrutsConfigPackage.STRUTS_CONFIG_TYPE__DATA_SOURCES, newDataSources, newDataSources));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public FormBeansType getFormBeans() {
		return formBeans;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public NotificationChain basicSetFormBeans(FormBeansType newFormBeans, NotificationChain msgs) {
		FormBeansType oldFormBeans = formBeans;
		formBeans = newFormBeans;
		if (eNotificationRequired()) {
			ENotificationImpl notification = new ENotificationImpl(this, Notification.SET, StrutsConfigPackage.STRUTS_CONFIG_TYPE__FORM_BEANS, oldFormBeans, newFormBeans);
			if (msgs == null) msgs = notification; else msgs.add(notification);
		}
		return msgs;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setFormBeans(FormBeansType newFormBeans) {
		if (newFormBeans != formBeans) {
			NotificationChain msgs = null;
			if (formBeans != null)
				msgs = ((InternalEObject)formBeans).eInverseRemove(this, EOPPOSITE_FEATURE_BASE - StrutsConfigPackage.STRUTS_CONFIG_TYPE__FORM_BEANS, null, msgs);
			if (newFormBeans != null)
				msgs = ((InternalEObject)newFormBeans).eInverseAdd(this, EOPPOSITE_FEATURE_BASE - StrutsConfigPackage.STRUTS_CONFIG_TYPE__FORM_BEANS, null, msgs);
			msgs = basicSetFormBeans(newFormBeans, msgs);
			if (msgs != null) msgs.dispatch();
		}
		else if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, StrutsConfigPackage.STRUTS_CONFIG_TYPE__FORM_BEANS, newFormBeans, newFormBeans));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public GlobalExceptionsType getGlobalExceptions() {
		return globalExceptions;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public NotificationChain basicSetGlobalExceptions(GlobalExceptionsType newGlobalExceptions, NotificationChain msgs) {
		GlobalExceptionsType oldGlobalExceptions = globalExceptions;
		globalExceptions = newGlobalExceptions;
		if (eNotificationRequired()) {
			ENotificationImpl notification = new ENotificationImpl(this, Notification.SET, StrutsConfigPackage.STRUTS_CONFIG_TYPE__GLOBAL_EXCEPTIONS, oldGlobalExceptions, newGlobalExceptions);
			if (msgs == null) msgs = notification; else msgs.add(notification);
		}
		return msgs;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setGlobalExceptions(GlobalExceptionsType newGlobalExceptions) {
		if (newGlobalExceptions != globalExceptions) {
			NotificationChain msgs = null;
			if (globalExceptions != null)
				msgs = ((InternalEObject)globalExceptions).eInverseRemove(this, EOPPOSITE_FEATURE_BASE - StrutsConfigPackage.STRUTS_CONFIG_TYPE__GLOBAL_EXCEPTIONS, null, msgs);
			if (newGlobalExceptions != null)
				msgs = ((InternalEObject)newGlobalExceptions).eInverseAdd(this, EOPPOSITE_FEATURE_BASE - StrutsConfigPackage.STRUTS_CONFIG_TYPE__GLOBAL_EXCEPTIONS, null, msgs);
			msgs = basicSetGlobalExceptions(newGlobalExceptions, msgs);
			if (msgs != null) msgs.dispatch();
		}
		else if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, StrutsConfigPackage.STRUTS_CONFIG_TYPE__GLOBAL_EXCEPTIONS, newGlobalExceptions, newGlobalExceptions));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public GlobalForwardsType getGlobalForwards() {
		return globalForwards;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public NotificationChain basicSetGlobalForwards(GlobalForwardsType newGlobalForwards, NotificationChain msgs) {
		GlobalForwardsType oldGlobalForwards = globalForwards;
		globalForwards = newGlobalForwards;
		if (eNotificationRequired()) {
			ENotificationImpl notification = new ENotificationImpl(this, Notification.SET, StrutsConfigPackage.STRUTS_CONFIG_TYPE__GLOBAL_FORWARDS, oldGlobalForwards, newGlobalForwards);
			if (msgs == null) msgs = notification; else msgs.add(notification);
		}
		return msgs;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setGlobalForwards(GlobalForwardsType newGlobalForwards) {
		if (newGlobalForwards != globalForwards) {
			NotificationChain msgs = null;
			if (globalForwards != null)
				msgs = ((InternalEObject)globalForwards).eInverseRemove(this, EOPPOSITE_FEATURE_BASE - StrutsConfigPackage.STRUTS_CONFIG_TYPE__GLOBAL_FORWARDS, null, msgs);
			if (newGlobalForwards != null)
				msgs = ((InternalEObject)newGlobalForwards).eInverseAdd(this, EOPPOSITE_FEATURE_BASE - StrutsConfigPackage.STRUTS_CONFIG_TYPE__GLOBAL_FORWARDS, null, msgs);
			msgs = basicSetGlobalForwards(newGlobalForwards, msgs);
			if (msgs != null) msgs.dispatch();
		}
		else if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, StrutsConfigPackage.STRUTS_CONFIG_TYPE__GLOBAL_FORWARDS, newGlobalForwards, newGlobalForwards));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public ActionMappingsType getActionMappings() {
		return actionMappings;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public NotificationChain basicSetActionMappings(ActionMappingsType newActionMappings, NotificationChain msgs) {
		ActionMappingsType oldActionMappings = actionMappings;
		actionMappings = newActionMappings;
		if (eNotificationRequired()) {
			ENotificationImpl notification = new ENotificationImpl(this, Notification.SET, StrutsConfigPackage.STRUTS_CONFIG_TYPE__ACTION_MAPPINGS, oldActionMappings, newActionMappings);
			if (msgs == null) msgs = notification; else msgs.add(notification);
		}
		return msgs;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setActionMappings(ActionMappingsType newActionMappings) {
		if (newActionMappings != actionMappings) {
			NotificationChain msgs = null;
			if (actionMappings != null)
				msgs = ((InternalEObject)actionMappings).eInverseRemove(this, EOPPOSITE_FEATURE_BASE - StrutsConfigPackage.STRUTS_CONFIG_TYPE__ACTION_MAPPINGS, null, msgs);
			if (newActionMappings != null)
				msgs = ((InternalEObject)newActionMappings).eInverseAdd(this, EOPPOSITE_FEATURE_BASE - StrutsConfigPackage.STRUTS_CONFIG_TYPE__ACTION_MAPPINGS, null, msgs);
			msgs = basicSetActionMappings(newActionMappings, msgs);
			if (msgs != null) msgs.dispatch();
		}
		else if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, StrutsConfigPackage.STRUTS_CONFIG_TYPE__ACTION_MAPPINGS, newActionMappings, newActionMappings));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public ControllerType getController() {
		return controller;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public NotificationChain basicSetController(ControllerType newController, NotificationChain msgs) {
		ControllerType oldController = controller;
		controller = newController;
		if (eNotificationRequired()) {
			ENotificationImpl notification = new ENotificationImpl(this, Notification.SET, StrutsConfigPackage.STRUTS_CONFIG_TYPE__CONTROLLER, oldController, newController);
			if (msgs == null) msgs = notification; else msgs.add(notification);
		}
		return msgs;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setController(ControllerType newController) {
		if (newController != controller) {
			NotificationChain msgs = null;
			if (controller != null)
				msgs = ((InternalEObject)controller).eInverseRemove(this, EOPPOSITE_FEATURE_BASE - StrutsConfigPackage.STRUTS_CONFIG_TYPE__CONTROLLER, null, msgs);
			if (newController != null)
				msgs = ((InternalEObject)newController).eInverseAdd(this, EOPPOSITE_FEATURE_BASE - StrutsConfigPackage.STRUTS_CONFIG_TYPE__CONTROLLER, null, msgs);
			msgs = basicSetController(newController, msgs);
			if (msgs != null) msgs.dispatch();
		}
		else if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, StrutsConfigPackage.STRUTS_CONFIG_TYPE__CONTROLLER, newController, newController));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EList getMessageResources() {
		if (messageResources == null) {
			messageResources = new EObjectContainmentEList(MessageResourcesType.class, this, StrutsConfigPackage.STRUTS_CONFIG_TYPE__MESSAGE_RESOURCES);
		}
		return messageResources;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EList getPlugIn() {
		if (plugIn == null) {
			plugIn = new EObjectContainmentEList(PlugInType.class, this, StrutsConfigPackage.STRUTS_CONFIG_TYPE__PLUG_IN);
		}
		return plugIn;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public NotificationChain eInverseRemove(InternalEObject otherEnd, int featureID, Class baseClass, NotificationChain msgs) {
		if (featureID >= 0) {
			switch (eDerivedStructuralFeatureID(featureID, baseClass)) {
				case StrutsConfigPackage.STRUTS_CONFIG_TYPE__DATA_SOURCES:
					return basicSetDataSources(null, msgs);
				case StrutsConfigPackage.STRUTS_CONFIG_TYPE__FORM_BEANS:
					return basicSetFormBeans(null, msgs);
				case StrutsConfigPackage.STRUTS_CONFIG_TYPE__GLOBAL_EXCEPTIONS:
					return basicSetGlobalExceptions(null, msgs);
				case StrutsConfigPackage.STRUTS_CONFIG_TYPE__GLOBAL_FORWARDS:
					return basicSetGlobalForwards(null, msgs);
				case StrutsConfigPackage.STRUTS_CONFIG_TYPE__ACTION_MAPPINGS:
					return basicSetActionMappings(null, msgs);
				case StrutsConfigPackage.STRUTS_CONFIG_TYPE__CONTROLLER:
					return basicSetController(null, msgs);
				case StrutsConfigPackage.STRUTS_CONFIG_TYPE__MESSAGE_RESOURCES:
					return ((InternalEList)getMessageResources()).basicRemove(otherEnd, msgs);
				case StrutsConfigPackage.STRUTS_CONFIG_TYPE__PLUG_IN:
					return ((InternalEList)getPlugIn()).basicRemove(otherEnd, msgs);
				default:
					return eDynamicInverseRemove(otherEnd, featureID, baseClass, msgs);
			}
		}
		return eBasicSetContainer(null, featureID, msgs);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public Object eGet(EStructuralFeature eFeature, boolean resolve) {
		switch (eDerivedStructuralFeatureID(eFeature)) {
			case StrutsConfigPackage.STRUTS_CONFIG_TYPE__ID:
				return getId();
			case StrutsConfigPackage.STRUTS_CONFIG_TYPE__VERSION:
				return getVersion();
			case StrutsConfigPackage.STRUTS_CONFIG_TYPE__DISPLAY_NAME:
				return getDisplayName();
			case StrutsConfigPackage.STRUTS_CONFIG_TYPE__DESCRIPTION:
				return getDescription();
			case StrutsConfigPackage.STRUTS_CONFIG_TYPE__DATA_SOURCES:
				return getDataSources();
			case StrutsConfigPackage.STRUTS_CONFIG_TYPE__FORM_BEANS:
				return getFormBeans();
			case StrutsConfigPackage.STRUTS_CONFIG_TYPE__GLOBAL_EXCEPTIONS:
				return getGlobalExceptions();
			case StrutsConfigPackage.STRUTS_CONFIG_TYPE__GLOBAL_FORWARDS:
				return getGlobalForwards();
			case StrutsConfigPackage.STRUTS_CONFIG_TYPE__ACTION_MAPPINGS:
				return getActionMappings();
			case StrutsConfigPackage.STRUTS_CONFIG_TYPE__CONTROLLER:
				return getController();
			case StrutsConfigPackage.STRUTS_CONFIG_TYPE__MESSAGE_RESOURCES:
				return getMessageResources();
			case StrutsConfigPackage.STRUTS_CONFIG_TYPE__PLUG_IN:
				return getPlugIn();
		}
		return eDynamicGet(eFeature, resolve);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void eSet(EStructuralFeature eFeature, Object newValue) {
		switch (eDerivedStructuralFeatureID(eFeature)) {
			case StrutsConfigPackage.STRUTS_CONFIG_TYPE__ID:
				setId((String)newValue);
				return;
			case StrutsConfigPackage.STRUTS_CONFIG_TYPE__VERSION:
				setVersion((String)newValue);
				return;
			case StrutsConfigPackage.STRUTS_CONFIG_TYPE__DISPLAY_NAME:
				setDisplayName((String)newValue);
				return;
			case StrutsConfigPackage.STRUTS_CONFIG_TYPE__DESCRIPTION:
				setDescription((String)newValue);
				return;
			case StrutsConfigPackage.STRUTS_CONFIG_TYPE__DATA_SOURCES:
				setDataSources((DataSourcesType)newValue);
				return;
			case StrutsConfigPackage.STRUTS_CONFIG_TYPE__FORM_BEANS:
				setFormBeans((FormBeansType)newValue);
				return;
			case StrutsConfigPackage.STRUTS_CONFIG_TYPE__GLOBAL_EXCEPTIONS:
				setGlobalExceptions((GlobalExceptionsType)newValue);
				return;
			case StrutsConfigPackage.STRUTS_CONFIG_TYPE__GLOBAL_FORWARDS:
				setGlobalForwards((GlobalForwardsType)newValue);
				return;
			case StrutsConfigPackage.STRUTS_CONFIG_TYPE__ACTION_MAPPINGS:
				setActionMappings((ActionMappingsType)newValue);
				return;
			case StrutsConfigPackage.STRUTS_CONFIG_TYPE__CONTROLLER:
				setController((ControllerType)newValue);
				return;
			case StrutsConfigPackage.STRUTS_CONFIG_TYPE__MESSAGE_RESOURCES:
				getMessageResources().clear();
				getMessageResources().addAll((Collection)newValue);
				return;
			case StrutsConfigPackage.STRUTS_CONFIG_TYPE__PLUG_IN:
				getPlugIn().clear();
				getPlugIn().addAll((Collection)newValue);
				return;
		}
		eDynamicSet(eFeature, newValue);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void eUnset(EStructuralFeature eFeature) {
		switch (eDerivedStructuralFeatureID(eFeature)) {
			case StrutsConfigPackage.STRUTS_CONFIG_TYPE__ID:
				setId(ID_EDEFAULT);
				return;
			case StrutsConfigPackage.STRUTS_CONFIG_TYPE__VERSION:
				setVersion(VERSION_EDEFAULT);
				return;
			case StrutsConfigPackage.STRUTS_CONFIG_TYPE__DISPLAY_NAME:
				setDisplayName(DISPLAY_NAME_EDEFAULT);
				return;
			case StrutsConfigPackage.STRUTS_CONFIG_TYPE__DESCRIPTION:
				setDescription(DESCRIPTION_EDEFAULT);
				return;
			case StrutsConfigPackage.STRUTS_CONFIG_TYPE__DATA_SOURCES:
				setDataSources((DataSourcesType)null);
				return;
			case StrutsConfigPackage.STRUTS_CONFIG_TYPE__FORM_BEANS:
				setFormBeans((FormBeansType)null);
				return;
			case StrutsConfigPackage.STRUTS_CONFIG_TYPE__GLOBAL_EXCEPTIONS:
				setGlobalExceptions((GlobalExceptionsType)null);
				return;
			case StrutsConfigPackage.STRUTS_CONFIG_TYPE__GLOBAL_FORWARDS:
				setGlobalForwards((GlobalForwardsType)null);
				return;
			case StrutsConfigPackage.STRUTS_CONFIG_TYPE__ACTION_MAPPINGS:
				setActionMappings((ActionMappingsType)null);
				return;
			case StrutsConfigPackage.STRUTS_CONFIG_TYPE__CONTROLLER:
				setController((ControllerType)null);
				return;
			case StrutsConfigPackage.STRUTS_CONFIG_TYPE__MESSAGE_RESOURCES:
				getMessageResources().clear();
				return;
			case StrutsConfigPackage.STRUTS_CONFIG_TYPE__PLUG_IN:
				getPlugIn().clear();
				return;
		}
		eDynamicUnset(eFeature);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public boolean eIsSet(EStructuralFeature eFeature) {
		switch (eDerivedStructuralFeatureID(eFeature)) {
			case StrutsConfigPackage.STRUTS_CONFIG_TYPE__ID:
				return ID_EDEFAULT == null ? id != null : !ID_EDEFAULT.equals(id);
			case StrutsConfigPackage.STRUTS_CONFIG_TYPE__VERSION:
				return VERSION_EDEFAULT == null ? version != null : !VERSION_EDEFAULT.equals(version);
			case StrutsConfigPackage.STRUTS_CONFIG_TYPE__DISPLAY_NAME:
				return DISPLAY_NAME_EDEFAULT == null ? displayName != null : !DISPLAY_NAME_EDEFAULT.equals(displayName);
			case StrutsConfigPackage.STRUTS_CONFIG_TYPE__DESCRIPTION:
				return DESCRIPTION_EDEFAULT == null ? description != null : !DESCRIPTION_EDEFAULT.equals(description);
			case StrutsConfigPackage.STRUTS_CONFIG_TYPE__DATA_SOURCES:
				return dataSources != null;
			case StrutsConfigPackage.STRUTS_CONFIG_TYPE__FORM_BEANS:
				return formBeans != null;
			case StrutsConfigPackage.STRUTS_CONFIG_TYPE__GLOBAL_EXCEPTIONS:
				return globalExceptions != null;
			case StrutsConfigPackage.STRUTS_CONFIG_TYPE__GLOBAL_FORWARDS:
				return globalForwards != null;
			case StrutsConfigPackage.STRUTS_CONFIG_TYPE__ACTION_MAPPINGS:
				return actionMappings != null;
			case StrutsConfigPackage.STRUTS_CONFIG_TYPE__CONTROLLER:
				return controller != null;
			case StrutsConfigPackage.STRUTS_CONFIG_TYPE__MESSAGE_RESOURCES:
				return messageResources != null && !messageResources.isEmpty();
			case StrutsConfigPackage.STRUTS_CONFIG_TYPE__PLUG_IN:
				return plugIn != null && !plugIn.isEmpty();
		}
		return eDynamicIsSet(eFeature);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public String toString() {
		if (eIsProxy()) return super.toString();

		StringBuffer result = new StringBuffer(super.toString());
		result.append(" (id: "); //$NON-NLS-1$
		result.append(id);
		result.append(", version: "); //$NON-NLS-1$
		result.append(version);
		result.append(", displayName: "); //$NON-NLS-1$
		result.append(displayName);
		result.append(", description: "); //$NON-NLS-1$
		result.append(description);
		result.append(')');
		return result.toString();
	}

} //StrutsConfigTypeImpl
